 import java.awt.*;
 import java.awt.event.*;
  abstract class BaseLanguage
   {
   abstract boolean sketchify(SketchyText skt0, SketchyText skt1,AmFrame fr);
   abstract void       reduce(Sketch s);
   abstract boolean textualize(SketchyText skt0, SketchyText skt1,AmFrame fr);
   abstract boolean normalize(SketchyText skt0, SketchyText skt1,AmFrame fr);
   abstract void      prepareTex(Sketch s);
   static final byte JAVA = 0;
   static final byte LATEX = 1;
   static final byte HTML = 2;
   static final byte NONE = 3;
   static final byte XML = 4;
   static final byte MATLAB = 5;
   static final byte EKFG = 6;
   static final byte SQL = 7;
   static final byte GRUPID=8;
   static String[] items =
     {
     "Java", "LaTex", "HTML",  
     AmLocale.None(), "XML", "Matlab", "EKFG","SQL","GRUPID"
     }
   ;
   static AmList list;
   byte type;
    static boolean userSetAll(Scheme s, AmFrame frame)
     {
     list = new AmList(items);
     AmDialog d = new AmDialog
     (frame, AmLocale.Base_language(),AmDialog.B_SELECT_CANCEL,
     AmLocale.Select_base_language()+".",
     (AmList)list);
     int bli = -999;
      switch(
      d.getTulemus()
      )
      {
       case
        AmDialog.CANCEL:
       return(
       false
       );
       case
        AmDialog.SELECT:
       bli = list.getSelectedIndex();
       break;
      }
      switch(
      bli
      )
      {
       case
        NONE:
       setAll(s, NONE);
       break;
       case
        JAVA:
       setAll(s, JAVA);
       break;
       case
        LATEX:
       setAll(s, LATEX);
       break;
       case
        HTML:
       setAll(s, HTML);
       break;
       case
        XML:
       setAll(s, XML);
       break;
       case
       MATLAB:
       setAll(s, MATLAB);
       break;
       case
       SQL:
       setAll(s, SQL);
       break;
       case
       GRUPID:
       setAll(s, GRUPID);
       break;
       case
       EKFG:
       setAll(s, EKFG);
      }
     return(
     true
     );
     }
    static void setAll(Scheme s, byte type)
     {
     s.baseLanguage = newBaseLanguage(type);
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Object o = s.member(i);
       if(
       (o instanceof Scheme)
       ){
       setAll((Scheme)o, type);
       }
       }
     }
    static BaseLanguage newBaseLanguage(byte type)
     {
      switch(
       type
      )
      {
       case
        JAVA:
       return(
       new BaseLanguageJava()
       );
       case
        LATEX:
       return(
       new BaseLanguageLaTex()
       );
       case
        HTML:
       return(
       new BaseLanguageHtml()
       );
       case
        XML:
       return(
       new BaseLanguageXML()
       );
       case
       MATLAB:
       return(
       new BaseLanguageMatlab()
       );
       case
       EKFG:
       return(
       new BaseLanguageEKFG()
       );
       case
       SQL:
       return(
       new BaseLanguageSQL()
       );
       case
       GRUPID:
       return(
       new BaseLanguageGRUPID()
       );
       case
        NONE:
       return(
       new BaseLanguage0()
       );
      }
     return(
     new BaseLanguage0()
     );
     }
    byte nextPrimitiveMemberType(byte prev)
     {
      switch(
      prev
      )
      {
       case
        Primitive.SIMPLE:
       return(
       Primitive.CONDITION
       );
       case
        Primitive.CONDITION:
       return(
       Primitive.STRONG_ARROW
       );
       case
        Primitive.STRONG_ARROW:
       case
        Primitive.WEAK_ARROW:
       return(
       Primitive.SIMPLE
       );
      }
     return(
     0
     );
     }
    byte nextSchemeType(Scheme s)
     {
      switch(
      s.type
      )
      {
       case
        Scheme.SIMPLE:
       return(
       Scheme.LOOP
       );
       case
        Scheme.LOOP:
       return(
       Scheme.MODULE
       );
       case
        Scheme.MODULE:
         {
         if(
         (s.comment.elements.size() > 1)
         ){
         return(
         Scheme.SIMPLE
         );
         }
         }
         {
         if(
         (s.parent == null)
         ){
         return(
         Scheme.SIMPLE
         );
         }
         }
         {
         if(
         (s instanceof Branch)
         ){
         return(
         Scheme.SIMPLE
         );
         }
         }
         {
         if(
         (((Sketch)s).isMono() && s.isHeadless())
         ){
         return(
         -1
         );
         }
         }
       return(
       Scheme.SIMPLE
       );
      }
     return(
     -1
     );
     }
    byte typeForBranchHead(Sketch s)
     {
       {
       if(
       (s.head.size() == 0)
       ){
       return(
       PrimitiveHead.SIMPLE
       );
       }
       }
      switch(
      s.primitiveHead(0).type
      )
      {
       case
        PrimitiveHead.SIMPLE:
       return(
       PrimitiveHead.SIMPLE
       );
       case
         PrimitiveHead.SWITCH:
       return(
       PrimitiveHead.CASE
       );
       case
         PrimitiveHead.TRY:
       return(
       PrimitiveHead.CATCH
       );
      }
     return(
     PrimitiveHead.SIMPLE
     );
     }
    byte nextPrimitiveHeadType(Scheme s, byte prev)
     {
      L0:
       {
         {
         if(
         (s instanceof Sketch)
         ){
          switch(
          prev
          )
          {
           case
            PrimitiveHead.SIMPLE:
           return(
           PrimitiveHead.LOOP
           );
           case
            PrimitiveHead.LOOP:
           return(
           PrimitiveHead.SWITCH
           );
           case
            PrimitiveHead.SWITCH:
           return(
           PrimitiveHead.TRY
           );
           case
            PrimitiveHead.TRY:
           return(
           PrimitiveHead.SIMPLE
           );
          }
         break L0;
         }
         }
       byte parentHeadType;
        L1:
         {
           {
           if(
           (s.parent.head.size() == 0)
           ){
           parentHeadType = -1;
           break L1;
           }
           }
         parentHeadType = s.parent.primitiveHead(0).type;
         }
         {
         if(
         (parentHeadType < 0)
         ){
          switch(
          prev
          )
          {
           case
            PrimitiveHead.SIMPLE:
           return(
           PrimitiveHead.LOOP
           );
           case
            PrimitiveHead.LOOP:
           return(
           PrimitiveHead.CASE
           );
           case
            PrimitiveHead.CASE:
           return(
           PrimitiveHead.DEFAULT
           );
           case
            PrimitiveHead.DEFAULT:
           return(
           PrimitiveHead.CATCH
           );
           case
            PrimitiveHead.CATCH:
           return(
           PrimitiveHead.FINALLY
           );
           case
            PrimitiveHead.FINALLY:
           return(
           PrimitiveHead.SIMPLE
           );
          }
         break L0;
         }
         }
        switch(
        parentHeadType
        )
        {
         case
          PrimitiveHead.SIMPLE:
         case
          PrimitiveHead.LOOP:
          switch(
          prev
          )
          {
           case
            PrimitiveHead.SIMPLE:
           return(
           PrimitiveHead.LOOP
           );
           case
            PrimitiveHead.LOOP:
           return(
           PrimitiveHead.CASE
           );
           case
            PrimitiveHead.CASE:
           return(
           PrimitiveHead.DEFAULT
           );
           case
            PrimitiveHead.DEFAULT:
           return(
           PrimitiveHead.CATCH
           );
           case
            PrimitiveHead.CATCH:
           return(
           PrimitiveHead.SIMPLE
           );
          }
         case
          PrimitiveHead.SWITCH:
          switch(
          prev
          )
          {
           case
            PrimitiveHead.CASE:
           return(
           PrimitiveHead.DEFAULT
           );
           case
            PrimitiveHead.DEFAULT:
           return(
           PrimitiveHead.CASE
           );
           default
            :
           {
           return(
           PrimitiveHead.CASE
           );
           }
          }
         case
          PrimitiveHead.TRY:
          switch(
          prev
          )
          {
           case
            PrimitiveHead.CATCH:
           return(
           PrimitiveHead.FINALLY
           );
           case
            PrimitiveHead.FINALLY:
           return(
           PrimitiveHead.CATCH
           );
           default
            :
           {
           return(
           PrimitiveHead.CATCH
           );
           }
          }
        }
       }
     return(
     prev
     );
     }
   }
