  class Cursor implements CursorMovements
   {
   Scheme scheme;
   Primitive primitive;
   Text text;
   Row row;
   int noInRow;
    Cursor(Scheme s)
     {
     scheme = s;
     row = null;
     }
    Cursor(Scheme s, Primitive p)
     {
     scheme = s;
     row = null;
     primitive = p;
     text = p.text;
     row = text.row(0);
     noInRow = 1;
     }
    Cursor makeCopy()
     {
     Cursor c = new Cursor(scheme);
     c.primitive = primitive;
     c.text = text;
     c.row = row;
     c.noInRow = noInRow;
     return(
     c
     );
     }
    boolean inScheme()
     {
     return(
     row != null
     );
     }
    boolean inPrimitive()
     {
     return(
     primitive != null
     );
     }
    boolean inSchemeComment()
     {
     return(
     inScheme() && !inPrimitive()
     );
     }
    boolean inHead()
     {
     return(
     inPrimitive() && (primitive instanceof PrimitiveHead)
     );
     }
    boolean inBody()
     {
     return(
     (inPrimitive() && (primitive instanceof PrimitiveMember))
     || (!inScheme())
     );
     }
    boolean inTextComment()
     {
     return(
     inPrimitive() && (text == null)
     );
     }
    int rowNo()
     {
       {
       if(
       (text != null)
       ){
       return(
       text.rows.indexOf(row)
       );
       }
       }
     return(
     -1
     );
     }
    public void moveToRowHome()
     {
     noInRow = 1;
     }
    public void moveToRowEnd()
     {
     noInRow = row.elements.size();
     }
    private boolean moveToNextRow()
     {
     int i, n;
     n = text.rows.size();
     i = text.rows.indexOf(row) + 1;
       {
       if(
       (i == n)
       ){
       return(
       false
       );
       }
       }
     row = text.row(i);
     moveToRowHome();
     return(
     true
     );
     }
    private boolean moveToPreviousRow()
     {
     int i, n;
     i = text.rows.indexOf(row);
       {
       if(
       (i == 0)
       ){
       return(
       false
       );
       }
       }
     row = text.row(i-1);
     //moveToRowEnd();
     noInRow = row.elements.size();
     return(
     true
     );
     }
    void moveToTextComment()
     {
     row = text.comment;
     text = null;
     moveToRowHome();
     }
    public void moveToPrimitiveText()
     {
     text = primitive.text;
     row = text.row(0);
     moveToRowHome();
     }
    public void moveToPrimitiveTextEnd()
     {
     text = primitive.text;
     row = (Row)(text.rows.lastElement());
     noInRow = row.elements.size();
     }
    public void moveToPrimitiveComment()
     {
     text = null;
     row = primitive.text.comment;
     moveToRowHome();
     }
    public void moveToPrimitiveEnd()
     {
     text = null;
     moveToPrimitiveComment();
     moveToRowEnd();
     }
    public void moveToHeadEnd()
     {
     primitive = (PrimitiveHead)(scheme.head.lastElement());
     moveToPrimitiveEnd();
     }
    boolean moveToNextElement()
     {
     int i, n;
       {
       if(
       (!inScheme())
       ){
       n = scheme.parent.body.size();
       i = scheme.parent.body.indexOf(scheme) + 1;
         {
         if(
         (i == n)
         ){
         return(
         false
         );
         }
         }
       Object o = scheme.parent.member(i);
         {
         if(
         (o instanceof Scheme)
         ){
         scheme = (Scheme)o;
         row = null;
         return(
         true
         );
         }
         }
       scheme = scheme.parent;
       primitive = (PrimitiveMember)o;
       moveToPrimitiveText();
       return(
       true
       );
       }
       }
       {
       if(
       (inHead())
       ){
       n = scheme.head.size();
       i = scheme.head.indexOf(primitive) + 1;
         {
         if(
         (i == n)
         ){
         return(
         false
         );
         }
         }
       primitive = scheme.primitiveHead(i);
       moveToPrimitiveText();
       return(
       true
       );
       }
       }
       {
       if(
       (inBody())
       ){
       Object o;
       n = scheme.body.size();
       i = scheme.body.indexOf(primitive) + 1;
        L0:
        for(
        ;;i++
        )
         {
           {
           if(
           (i == n)
           ){
           return(
           false
           );
           }
           }
         o = scheme.member(i);
           {
           if(
           (o instanceof Scheme)
           ){
           Scheme s = (Scheme)o;
             {
             if(
             (s.icon)
             ){
             continue L0;
             }
             }
           scheme = s;
           row = null;
           return(
           true
           );
           }
           }
         break;
         }
       primitive = (PrimitiveMember)o;
       moveToPrimitiveText();
       return(
       true
       );
       }
       }
     return(
     false
     );
     }
    boolean moveToPreviousElement()
     {
     int i;
       {
       if(
       (!inScheme())
       ){
       i = scheme.parent.body.indexOf(scheme);
         {
         if(
         (i == 0)
         ){
         return(
         false
         );
         }
         }
       Object o = scheme.parent.member(i-1);
         {
         if(
         (o instanceof Scheme)
         ){
         scheme = (Scheme)o;
         row = null;
         return(
         true
         );
         }
         }
       scheme = scheme.parent;
       primitive = (PrimitiveMember)o;
       moveToPrimitiveText();
       return(
       true
       );
       }
       }
       {
       if(
       (inHead())
       ){
       i = scheme.head.indexOf(primitive);
         {
         if(
         (i == 0)
         ){
         return(
         false
         );
         }
         }
       primitive = scheme.primitiveHead(i - 1);
       moveToPrimitiveEnd();
       return(
       true
       );
       }
       }
       {
       if(
       (inBody())
       ){
       Object o;
       i = scheme.body.indexOf(primitive);
        L1:
        for(
        ;;i--
        )
         {
           {
           if(
           (i == 0)
           ){
           return(
           false
           );
           }
           }
         o = scheme.member(i - 1);
           {
           if(
           (o instanceof Scheme)
           ){
           Scheme s = (Scheme)o;
             {
             if(
             (s.icon)
             ){
             continue L1;
             }
             }
           scheme = s;
           row = null;
           return(
           true
           );
           }
           }
         break;
         }
       primitive = (PrimitiveMember)o;
       moveToPrimitiveEnd();
       return(
       true
       );
       }
       }
     return(
     false
     );
     }
    public void moveToParentHome()
     {
     primitive = null;
     text = null;
     row = scheme.comment;
     moveToRowHome();
     }
    public void moveToParentParentHome()
     {
     primitive = null;
     text = null;
     scheme = scheme.parent;
     row = scheme.comment;
     moveToRowHome();
     }
    public void moveToParentEnd()
     {
     Primitive p = null;
     Scheme s = null;
     int n = scheme.body.size();
      L2:
      for(
      int i = n-1; i >= 0; i--
      )
       {
       Object o = scheme.member(i);
         {
         if(
         (o instanceof Scheme)
         ){
           {
             {
             if(
             (((Scheme)o).icon)
             ){
             continue L2;
             }
             }
           s = (Scheme)o;
           }
         break L2;
         }
         }
       p = (Primitive)o;
       break;
       }
       {
       if(
       (s != null)
       ){
       scheme = s;
       moveToParentEnd();
       return;
       }
       }
       {
       if(
       (p != null)
       ){
       primitive = p;
       moveToPrimitiveText();
       moveToPrimitiveEnd();
       return;
       }
       }
       {
       if(
       (scheme.head.size() == 0)
       ){
       moveToParentHome();
       moveToRowEnd();
       return;
       }
       }
     primitive = (PrimitiveHead)(scheme.head.lastElement());
     moveToPrimitiveComment();
     moveToRowEnd();
     return;
     }
    public boolean moveToHead()
     {
       {
       if(
       (scheme.head.size() == 0)
       ){
       return(
       false
       );
       }
       }
     primitive = scheme.primitiveHead(0);
     moveToPrimitiveText();
     return(
     true
     );
     }
    public boolean moveToHead(int i)
     {
       {
       if(
       (scheme.head.size()-1 < i)
       ){
       return(
       false
       );
       }
       }
     primitive = scheme.primitiveHead(i);
     moveToPrimitiveText();
     return(
     true
     );
     }
    public boolean moveToBody()
     {
     Object o;
     int n = scheme.body.size();
      L3:
      for(
      int i = 0; i < n; i++
      )
       {
       o = scheme.member(i);
         {
         if(
         (o instanceof Scheme)
         ){
         Scheme ss = (Scheme)o;
           {
           if(
           (ss.icon)
           ){
           continue L3;
           }
           }
         scheme = ss;
         moveToParentHome();
         return(
         true
         );
         }
         }
       primitive = (PrimitiveMember)o;
       moveToPrimitiveText();
       return(
       true
       );
       }
     return(
     false
     );
     }
    private boolean moveToNextMember()
     {
     Object o = null;
     Scheme father = scheme.parent;
       {
       if(
       (father == null)
       ){
       return(
       false
       );
       }
       }
     int n = father.body.size();
     int i = father.body.indexOf(scheme) + 1;
      L4:
      for(
      ;;i++
      )
       {
         {
         if(
         (i < n)
         ){
         o = father.member(i);
           {
           if(
           (o instanceof Scheme)
           ){
           Scheme s = (Scheme)o;
             {
             if(
             (s.icon)
             ){
             continue L4;
             }
             }
           scheme = s;
           moveToParentHome();
           return(
           true
           );
           }
           }
         break L4;
         }
         }
       break;
       }
       {
       if(
       (i < n)
       ){
       scheme = father;
       primitive = (PrimitiveMember)o;
       moveToPrimitiveText();
       return(
       true
       );
       }
       }
     Scheme keepScheme = scheme;
     scheme = father;
       {
       if(
       (moveToNextMember())
       ){
       return(
       true
       );
       }
       }
     scheme = keepScheme;
     return(
     false
     );
     }
    boolean moveToPreviousMember()
     {
     Object o = null;
     Scheme father = scheme.parent;
       {
       if(
       (father == null)
       ){
       return(
       false
       );
       }
       }
     int i = father.body.indexOf(scheme) - 1;
      L5:
      for(
      ;;i--
      )
       {
         {
         if(
         (i >= 0)
         ){
         o = father.member(i);
           {
           if(
           (o instanceof Scheme)
           ){
           Scheme s = (Scheme)o;
             {
             if(
             (s.icon)
             ){
             continue L5;
             }
             }
           scheme = s;
           moveToParentEnd();
           return(
           true
           );
           }
           }
         break L5;
         }
         }
       break;
       }
       {
       if(
       (i >= 0)
       ){
       scheme = father;
       primitive = (PrimitiveMember)o;
       moveToPrimitiveEnd();
       return(
       true
       );
       }
       }
     scheme = father;
     moveToParentHome();
      L6:
       {
         {
         if(
         (scheme.head.size() == 0)
         ){
         moveToRowEnd();
         break L6;
         }
         }
       moveToHeadEnd();
       }
     return(
     true
     );
     }
    public boolean moveDown()
     {
       {
       if(
       (!inScheme())
       ){
       moveToParentHome();
       return(
       true
       );
       }
       }
       {
       if(
       (inSchemeComment())
       ){
         {
         if(
         (moveToHead())
         ){
         return(
         true
         );
         }
         }
         {
         if(
         (moveToBody())
         ){
         return(
         true
         );
         }
         }
         {
         if(
         (moveToNextMember())
         ){
         return(
         true
         );
         }
         }
       return(
       false
       );
       }
       }
       {
       if(
       (inTextComment())
       ){
         {
         if(
         (moveToNextElement())
         ){
           {
           if(
           (row == null)
           ){
           moveToParentHome();
           }
           }
         return(
         true
         );
         }
         }
         {
         if(
         (inHead())
         ){
           {
           if(
           (moveToBody())
           ){
           return(
           true
           );
           }
           }
           {
           if(
           (moveToNextMember())
           ){
           return(
           true
           );
           }
           }
         return(
         false
         );
         }
         }
         {
         if(
         (moveToNextMember())
         ){
         return(
         true
         );
         }
         }
       return(
       false
       );
       }
       }
       {
       if(
       (moveToNextRow())
       ){
       return(
       true
       );
       }
       }
     moveToTextComment();
     return(
     true
     );
     }
    public boolean moveRight()
     {
       {
       if(
       (!inScheme())
       ){
       moveToParentHome();
       return(
       true
       );
       }
       }
       {
       if(
       (noInRow == row.elements.size())
       ){
       return(
       moveDown()
       );
       }
       }
     noInRow++;
     return(
     true
     );
     }
    public boolean moveUp()
     {
       {
       if(
       (!inScheme())
       ){
       moveToParentHome();
       return(
       true
       );
       }
       }
       {
       if(
       (inSchemeComment())
       ){
       return(
       moveToPreviousMember()
       );
       }
       }
       {
       if(
       (inTextComment())
       ){
       moveToPrimitiveTextEnd();
       return(
       true
       );
       }
       }
       {
       if(
       (moveToPreviousRow())
       ){
       return(
       true
       );
       }
       }
       {
       if(
       (moveToPreviousElement())
       ){
         {
         if(
         (row == null)
         ){
         moveToParentEnd();
         }
         }
       return(
       true
       );
       }
       }
      L8:
       {
         {
         if(
         (inBody())
         ){
          L7:
           {
             {
             if(
             (scheme.head.size() == 0)
             ){
             moveToParentHome();
             moveToRowEnd();
             break L7;
             }
             }
           moveToHeadEnd();
           }
         break L8;
         }
         }
       if(
       (inHead())
       ){
       moveToParentHome();
       moveToRowEnd();
       }
       }
     return(
     true
     );
     }
    public boolean moveLeft()
     {
       {
       if(
       (!inScheme())
       ){
       moveToParentHome();
       return(
       true
       );
       }
       }
       {
       if(
       (noInRow == 1)
       ){
       return(
       moveUp()
       );
       }
       }
     noInRow--;
     return(
     true
     );
     }
    boolean scanRow()
     {
       {
       if(
       (noInRow >= row.elements.size())
       ){
       return(
       false
       );
       }
       }
     row.getElement(noInRow);
     noInRow++;//moveRight();
     return(
     true
     );
     }
   }
