import java.io.*;
import java.util.*;
/**
 * Tehakse plain-HTML-ist vo~i HTML-ist klass,
 * mis sisaldab stringide jadana plain-HTML-i vo~i HTML-i 
 *
 *@author J.Kiho
 */
class HelpMake {
    // tulemusfail
    static PrintWriter out;
    /** Loetav fail */
    static FileReader in;
    /** Textifailist loetud symbol, -1, kui faili lopp */
    static int c;
    
    // Kirjutame etteantud stringi faili
    static void write2file (String buf) {
	out.println(buf);
    } // write2file
  
    static String readLn() {
    // Loeme yhe rea failist, tagastame String tyypi objekti
	String s = "";
	// loeme char-i kaupa failist, 
	// ise kontrollime kas pole faili l6pp v6i reavahetus
	try {
	    c = in.read();
    
	    while ((c != -1) && ((char) c != '\n')) {
		if(c != '\r') {
			if(c == '\"') s = s + '\\';// langkriips " ette
			else if(c == '\\') s = s + '\\';// langkriips \ ette
			s = s + (char) c;
		} 
		c = in.read();
	    }
	}
	// kui juhtus mingi jama, siis saame exceptioni
	catch (IOException e) {
	    System.err.println("Caught IOException: " + e.getMessage());
	}
	// tagastame loetud rea
	return s;
    } // readLn

    static public void makeClass(String from, String to, 
			     String className) {
	// Avame etteantud nimelise faili
	try {
	    out = new PrintWriter(new FileWriter(to));
	}
	// pyyame exceptioni kui ei 6nnestunud faili luua
	catch (IOException e) {
	    System.err.println("Caught IOException: " + e.getMessage());
	}
	// Avame etteantud nimelise faili
	try {
	    in = new FileReader(from);
	}
	// pyyame erindi, kui ei 6nnestunud faili avada
	catch (IOException e) {
	    System.err.println("Caught IOException: " + e.getMessage());
	}
	// algus
	write2file("class "+className+"{");
        write2file("static String s[] = {");
	// 1.rida
	write2file("\""+readLn()+"\"");
	// read
	for(;;){
	    write2file(",\""+readLn()+"\"");
	    if (c == -1) break;
	}
	// kui la"htefailis oli lo~pus reavahetus, 
	// siis tuli veel tyhi rida ("");
	
	// lo~pp
	write2file("};}");

	// failid kinni
	out.close();
	try{in.close();}
	    catch (IOException e){}
	    
	// tehtud:
	System.out.println("HelpMake DONE:");
	System.out.println("         from: "+from);
	System.out.println("           to: "+to);

    }
    public static void main(String[] argv){
	if(argv.length != 3){
	    System.out.println("Usage:");
	    System.out.println("java HelpMake arg1 arg2 arg3");
	    System.out.println(
	    "     arg1 = full name of source plain-HTML or HTML file (as exported from AMADEUS)");
	    System.out.println(
	    "     arg2 = destination directory");
	    System.out.println(
	    "     arg3 = destination class name (e.g. Help0)");
	    System.exit(0);
	}   
	   
	if(argv[1].charAt(argv[1].length()-1) != '/')    
	    makeClass(argv[0], 
			argv[1]+"/"+argv[2]+".java", argv[2]);
	else
	    makeClass(argv[0], 
			argv[1]+argv[2]+".java", argv[2]);
	
    }
}