 import java.util.*;
 import java.awt.*;
  class Editor
   {
   SketchyText sketchyText;
   UndoStack stack;
   RedoStack redoStack;
   Caret caret;
   boolean isRedoing;
   final String TEADE_SKEEMI_LISAMISEL =
             AmLocale.Scheme() + " " +
             AmLocale.contains() +" "+ AmLocale.leaving_arrows()+"!";
   
    Editor(SketchyText skt)
     {
     sketchyText = skt;
     stack = null;
     redoStack = null;
     caret = new Caret(skt.main);
     caret.moveToParentHome();
     isRedoing = true;
     }
    public  void deleteScheme(Scheme s)
     {
     stack.push(new UndoDeleteScheme(s, s.parent.body.indexOf(s), caret));
     redoStack.setEmpty();
     AmCanvas c = sketchyText.frame.viewArea;
     c.caretToScreen = true;
     Rectangle rk = new Rectangle(s.view.x,s.view.y,
     s.view.width,s.view.height);
      for(
      ;rk.contains(caret.row.x, caret.row.y+caret.height);
      )
       {
       caret.moveUp();
       }
     s.remove();
     }
    public void cutMembers(Branch br, int i0, int j0)
     {
     stack.push(new UndoCutMembers(br, i0, j0, caret));
     redoStack.setEmpty();
     AmCanvas c = sketchyText.frame.viewArea;
     Rectangle rk = c.selection.area();
      for(
      ;rk.contains(caret.row.x, caret.row.y+caret.height);
      )
       {
       caret.moveUp();
       }
      for(
      int i = i0; i <= j0; i++
      )
       {
       br.removeMember(i0);
       }
     }
    public void cutHeads(Scheme s, int i0, int j0)
     {
     stack.push(new UndoCutHeads(s, i0, j0, caret));
     redoStack.setEmpty();
     AmCanvas c = sketchyText.frame.viewArea;
     Rectangle rk = c.selection.area();
      for(
      ;rk.contains(caret.row.x, caret.row.y+caret.height-2);
      )
       {
       caret.moveUp();
       }
      for(
      int i = i0; i <= j0; i++
      )
       {
       s.removePrimitiveHead(i0);
       }
     }
    public Object insertMembers(Branch br, int i, Vector v)
     {
     boolean leavingArrows = false;
     redoStack.setEmpty();
     Object res = null;
     stack.push(new UndoInsertMembers(br, i, v.size()-1, caret));
      L0:
      for(
      int j = 1; j < v.size(); j++
      )
       {
       Object o = v.elementAt(j);
         {
         if(
         o instanceof Sketch
         ){
         Sketch s = (Sketch)o;
         s = s.makeCopy();
           {
           if(
           s.hasLeavingArrows(0)
           ){
           leavingArrows = true;
           AmDialog d = new AmDialog(sketchyText.frame, "NB!",
           AmDialog.B_OK, TEADE_SKEEMI_LISAMISEL);
           }
           }
         ((Sketch)s).incrementArrows(br.level()+1);
         br.insert(s, i++);
           {
           if(
           leavingArrows
           ){
           s.correctLeavingArrows();
           }
           }
           {
           if(
           j == 1
           ){
           res = s;
           }
           }
         continue L0;
         }
         }
       PrimitiveMember p = (PrimitiveMember)o;
       p = p.makeCopy();
       br.insert(p, i++);
       if(
       (j == 1)
       ){
       res = p;
       }
       }
     return(
     res
     );
     }
    public PrimitiveHead insertHeads(Scheme s, int i, Vector v)
     {
     PrimitiveHead res = null;
     redoStack.setEmpty();
     stack.push(new UndoInsertHeads(s, i, v.size()-1, caret));
      for(
      int j = 1; j < v.size(); j++
      )
       {
       PrimitiveHead he = (PrimitiveHead)(v.elementAt(j));
       he = he.makeCopy();
        L1:
         {
           {
           if(
           ((s instanceof Sketch) &&
           (he.text.isMonochrome(Default.branchHeadColor)))
           ){
           he.text.setColor(Default.sketchHeadColor);
           break L1;
           }
           }
         if(
         ((s instanceof Branch) &&
         (he.text.isMonochrome(Default.sketchHeadColor)))
         ){
         he.text.setColor(Default.branchHeadColor);
         }
         }
       s.insert(he, i++);
       if(
       (j == 1)
       ){
       res = he;
       }
       }
     return(
     res
     );
     }
    public void insertElements(Vector v)
     {
       {
       if(
       (caret.row == null)
       ){
       return;
       }
       }
     stack.push(new UndoInsertElements(v.size()-1, caret));
     redoStack.setEmpty();
     Color col = caret.row.isMonochrome();
      L2:
      for(
      int i = caret.noInRow, j = 1; j < v.size(); j++, i++
      )
       {
       Object o = v.elementAt(j);
         {
         if(
         (o instanceof Symbol)
         ){
         Symbol sy = (Symbol)o;
         sy = new Symbol(sy.c, sy.font, sy.color);
           {
           if(
           (col != null)
           ){
           sy.color = col;
           }
           }
         caret.row.elements.insertElementAt(sy, i);
         continue L2;
         }
         }
       ;
       }
     caret.row.planSize();
     }
    public  void insertRows(Vector v)
     {
       {
       if(
       caret.row == null
       ){
       return;
       }
       }
     Vector vect = new Vector();
     int i = caret.rowNo();
     vect.addElement(caret.text.row(i).makeCopy());
     redoStack.setEmpty();
     stack.push(new UndoInsertRows(caret.text,caret,i,v.size()-1,vect));
     Color col = caret.text.isMonochrome();
     caret.text.splitRow(i, caret.noInRow);
     int k = i+1;
      L3:
       {
         {
         if(
         col == null
         ){
          for(
          int j = 1; j < v.size(); j++
          )
           {
           caret.text.insert(((Row)(v.elementAt(j))).makeCopy(),k++);
           }
         break L3;
         }
         }
        for(
        int j = 1; j < v.size(); j++
        )
         {
         Row r = ((Row)(v.elementAt(j))).makeCopy();
         r.setColor(col);
         caret.text.insert(r, k++);
         }
       }
     caret.text.joinRow(k);
     caret.text.joinRow(k);
     caret.text.joinRow(i+1);
     caret.row = caret.text.row(i);
     }
    public  void cutPrimitive(Scheme s, Primitive p)
     {
     int k;
     redoStack.setEmpty();
      L4:
       {
         {
         if(
         (p instanceof PrimitiveHead)
         ){
         	                                                                                                                                                                                              k = s.head.indexOf(p);
         break L4;
         }
         }
       k = s.body.indexOf(p);
       }
     stack.push(new UndoCutPrimitive(s, p, k, caret));
     AmCanvas c = (AmCanvas)(sketchyText.frame.viewArea);
     c.caretToScreen = true;
     Rectangle rk = new Rectangle(p.text.x,p.text.y,
     p.text.width,p.text.height);
      for(
      ;rk.contains(caret.row.x, caret.row.y);
      )
       {
       caret.moveUp();
       }
      L5:
       {
         {
         if(
         (p instanceof PrimitiveHead)
         ){
         s.head.removeElement(p);
         break L5;
         }
         }
       s.body.removeElement(p);
       }
     }
    public  void cutFromRow(Row r, int i, int j, boolean car)
     {
     stack.push(new UndoCutFromRow(r, i, j, caret));
     redoStack.setEmpty();
       {
       if(
       (car)
       ){
       caret.moveToRowHome();
       }
       }
      for(
      int k = i; k < j; k++
      )
       {
       r.elements.removeElementAt(i);
       }
     r.planSize();
     }
    public  void cutFromText(Text t, Row r1, int ii,Row r2, int jj,
    boolean car)
     {
       {
       if(
       (car)
       ){
       caret.moveToPrimitiveText();
       }
       }
     Row r;
     int ir1 = t.rows.indexOf(r1);
     int ir2 = t.rows.indexOf(r2);
     int i, n;
     int nr = 2;
     Vector vect = new Vector();
      for(
      i = ir1; i <= ir2; i++
      )
       {
       vect.addElement(t.row(i).makeCopy());
       }
      for(
      i = ir1+1; i <= ir2-1; i++
      )
       {
       t.rows.removeElementAt(ir1+1);
       }
     n = r1.elements.size();
      for(
      i = ii; i < n; i++
      )
       {
       r1.elements.removeElementAt(ii);
       }
     r1.planSize();
      for(
      i = 1; i < jj; i++
      )
       {
       r2.elements.removeElementAt(1);
       }
      L6:
       {
         {
         if(
         (r2.elements.size() == 1)
         ){
         t.rows.removeElementAt(ir1+1);
         nr--;
         break L6;
         }
         }
       r2.planSize();
       }
     redoStack.setEmpty();
     stack.push(new UndoCutFromText(t, caret,ir1,nr,vect));
     }
    public void insertScheme(Scheme where, int i, Scheme s)
     {
     boolean leavingArrows = false;
     stack.push(new UndoInsertScheme(s, caret,i));
     redoStack.setEmpty();
      L7:
       {
         {
         if(
         s instanceof Sketch
         ){
           {
           if(
           s.hasLeavingArrows(0)
           ){
           leavingArrows = true;
           AmDialog d = new AmDialog(sketchyText.frame, "NB!",
           AmDialog.B_OK, TEADE_SKEEMI_LISAMISEL);
           }
           }
         ((Sketch)s).incrementArrows(where.level()+1);
         where.insert((Sketch)s, i);
           {
           if(
           leavingArrows
           ){
           s.correctLeavingArrows();
           }
           }
         break L7;
         }
         }
         {
         if(
         s.hasLeavingArrows(-1)
         ){
         leavingArrows = true;
         AmDialog d = new AmDialog(sketchyText.frame, "NB!",
         AmDialog.B_OK, TEADE_SKEEMI_LISAMISEL);
         }
         }
       ((Branch)s).incrementArrows(where.level()+1);
       where.insert((Branch)s, i);
         {
         if(
         leavingArrows
         ){
         s.correctLeavingArrows();
         }
         }
       }
     caret.goTo(s);
     }
    public void insertHead(Scheme s, int i, PrimitiveHead h)
     {
     stack.push(new UndoInsertHead(s, caret, i));
     redoStack.setEmpty();
     s.insert(h, i);
     caret.moveToHead(i);
     }
    public void insertPrimitive(Scheme s, int i, PrimitiveMember p)
     {
     stack.push(new UndoInsertPrimitive(s, caret, i));
     redoStack.setEmpty();
     s.insert(p, i);
     caret.scheme = s;
     caret.primitive = p;
     caret.moveToPrimitiveText();
     }
    public void insertCharAtCaretRight(char c)
     {
      L8:
      for(
      int i = caret.noInRow-1; ; i--
      )
       {
       caret.row.getElement(i);
         {
         if(
         caret.row.sy != null
         ){
         break L8;
         }
         }
       }
     Symbol s = new Symbol(c, caret.row.sy.font,
     caret.row.sy.color);
     stack.push(new UndoInsertCharAtCaretRight(caret, caret.rowNo(),s));
     redoStack.setEmpty();
     caret.row.insert(s, caret.noInRow);
     caret.row.planSize();
       {
       if(
       (caret.text != null)
       ){
       caret.text.plan(0, 0);
       }
       }
     }
    public void insertCharAtCaretLeft(char c)
     {
     insertCharAtCaretRight(c);
     redoStack.setEmpty();
     caret.moveRight();
     }
    public void insertCharAtCaretLeft(String nimi)
     {
     Am.pictureBoard.processIMGs( caret.row , caret.noInRow ,nimi);
     redoStack.setEmpty();
     caret.moveRight();
     }
    public void deleteElementAtCaretLeft()
     {
     caret.moveLeft();
     redoStack.setEmpty();
     stack.push(new UndoDeleteElementAtCaretLeft(
     caret,
     caret.rowNo(),
     caret.row.element(caret.noInRow)));
     caret.row.remove(caret.noInRow);
     caret.row.planSize();
     }
    public void deleteElementAtCaretRight()
     {
     stack.push(new UndoDeleteElementAtCaretRight(
                     caret,caret.rowNo(),caret.row.element(caret.noInRow)));
     caret.row.remove(caret.noInRow);
     redoStack.setEmpty();
     caret.row.planSize();
     }
    public void empty(Row r)
     {
     stack.push(new UndoEmptyRow(caret, r));
     redoStack.setEmpty();
     r.removeAll();
     r.planSize();
       {
       if(
       (caret.text == null)
       ){
       caret.moveToRowHome();
       }
       }
     }
    public void empty(Text t)
     {
     stack.push(new UndoEmptyText(caret, t));
     redoStack.setEmpty();
      for(
      ;t.rows.size() > 1;
      )
       {
       t.remove(1);
       }
     ((Row)(t.row(0))).removeAll();
     ((Row)(t.row(0))).planSize();
       {
       if(
       (caret.text != null)
       ){
       caret.moveToPrimitiveText();
       }
       }
     }
    public  void splitRowAtCaret()
     {
     stack.push(new UndoSplitRowAtCaret(caret));
     redoStack.setEmpty();
     int i = caret.rowNo();
     caret.text.splitRow(i, caret.noInRow);
     caret.moveDown();
     caret.moveToRowHome();
     }
    public  void joinRowAtCaret()
     {
     int i = caret.rowNo();
     redoStack.setEmpty();
     caret.moveUp();
     caret.moveToRowEnd();
     caret.text.joinRow(i);
     stack.push(new UndoJoinRowAtCaret(caret));
     }
    public  void joinRowAtCaretNext()
     {
     int i = caret.rowNo()+1;
     redoStack.setEmpty();
     caret.text.joinRow(i);
     stack.push(new UndoJoinRowAtCaretNext(caret));
     }
    public  boolean togglePrimitive()
     {
     Color color = Default.foregroundColor;;
     redoStack.setEmpty();
     byte newType = 0;
      L9:
       {
         {
         if(
         caret.inBody()
         ){
         newType =
         caret.scheme.baseLanguage.nextPrimitiveMemberType(
         caret.primitive.type);
         break L9;
         }
         }
       if(
       caret.inHead()
       ){
       newType =
       caret.scheme.baseLanguage.nextPrimitiveHeadType(
       caret.scheme, caret.primitive.type);
         {
         if(
         newType == caret.primitive.type
         ){
         return(
         false
         );
         }
         }
       stack.push(new UndoTogglePrimitive(
       caret.primitive));
       caret.primitive.type = newType;
       return(
       true
       );
       }
       }
       {
       if(
       newType == caret.primitive.type
       ){
       return(
       false
       );
       }
       }
      switch(
      newType
      )
      {
       case
        Primitive.CONDITION:
       color = Default.conditionColor;
        L10:
         {
           {
           if(
           (caret.primitive.text.isMonochrome(
           Default.foregroundColor))
           ){
           stack.push(new UndoTogglePrimitive(
                            caret.primitive, Default.foregroundColor));
           caret.primitive.text.setColor(color);
           break L10;
           }
           }
         stack.push(new UndoTogglePrimitive(caret.primitive,null));
         }
       caret.primitive.type = newType;
       break;
       case
        Primitive.STRONG_ARROW:
       case
        Primitive.WEAK_ARROW:
       int no = caret.scheme.body.indexOf(caret.primitive);
       Text t = caret.primitive.text;
        L11:
         {
           {
           if(
           (t.isMonochrome(Default.conditionColor))
           ){
           stack.push(new UndoTogglePrimitive(
           caret, Default.conditionColor , no));
           t.setColor(Default.foregroundColor);
           break L11;
           }
           }
         stack.push(new UndoTogglePrimitive(
         caret, null, no));
         }
       caret.primitive = new Arrow(Arrow.STRONG,
       caret.scheme.level()-1);
       caret.primitive.text = t;
       caret.scheme.body.removeElementAt(no);
       caret.scheme.body.insertElementAt
       (caret.primitive, no);
       break;
       case
        Primitive.SIMPLE:
       no = caret.scheme.body.indexOf(caret.primitive);
       t = caret.primitive.text;
       stack.push(new UndoTogglePrimitive(caret, null, no));
       caret.primitive = new PrimitiveMember(Primitive.SIMPLE, new Text());
       caret.primitive.text = t;
       caret.scheme.body.removeElementAt(no);
       caret.scheme.body.insertElementAt
       (caret.primitive, no);
       break;
      }
     return(
     true
     );
     }
    public  void toggleColorInRow(Selection sel, Row r, int i, int j)
     {
     stack.push(new UndoToggleColorInRow(sel, r, i, j));
     redoStack.setEmpty();
     r.toggleColor(i, j);
     }
    public  void toggleColorInText(Selection sel,
                                                  Text t, Row r1, int ii, Row r2, int jj)
     {
     int ir1 = t.rows.indexOf(r1);
     redoStack.setEmpty();
     int ir2 = t.rows.indexOf(r2);
     stack.push(new UndoToggleColorInText(
     sel, t, r1, ir1, ii, r2, ir2, jj));
     int i;
      for(
      i = ir1+1; i < ir2; i++
      )
       {
       t.row(i).toggleColor();
       }
     r1.toggleColor(ii, r1.elements.size()-1);
     r2.toggleColor(0, jj);
     }
    public void toggleColorInPrimitive(Selection sel)
     {
     Primitive p = sel.start.primitive;
     redoStack.setEmpty();
     stack.push(new UndoToggleColorInPrimitive(p));
     p.text.toggleColor(true);
     }
    public  void setColorInRow(Selection sel, Row r, int i, int j,
    Color col)
     {
     stack.push(new UndoToggleColorInRow(sel, r, i, j));
     redoStack.setEmpty();
     r.setColor(i, j, col);
     }
    public  void setStyleInRow(Selection sel, Row r, int i, int j,
    Color col, Font font)
     {
     stack.push(new UndoSetStyleInRow(sel, r, i, j));
     redoStack.setEmpty();
     r.setStyle(i, j, col, font);
     }
    public  void setStyleInText(Selection sel,Text t, Row r1, int ii, Row r2, int jj, Color col, Font font)
     {
     int ir1 = t.rows.indexOf(r1);
     redoStack.setEmpty();
     int ir2 = t.rows.indexOf(r2);
     //stack.push(new UndoSetStyleInText(sel, t, r1, ir1, ii, r2, ir2, jj));
     int i;
      for(
      i = ir1+1; i < ir2; i++
      )
       {
       t.row(i).setStyle(col, font);
       }
     r1.setStyle(ii, r1.elements.size()-1, col, font);
     r2.setStyle(0, jj, col, font);
     }
    public void setStyleInPrimitive(Selection sel,Color col, Font font)
     {
     Primitive p = sel.start.primitive;
     redoStack.setEmpty();
     p.text.setStyle(col, font);
     }
    public  boolean toggleScheme(Scheme s)
     {
     boolean res = false;
     redoStack.setEmpty();
     byte newType = 0;
     newType =
     s.baseLanguage.nextSchemeType(s);
       {
       if(
       (newType == s.type)
       ){
       return(
       res
       );
       }
       }
      L12:
       {
         {
         if(
         (newType < 0)
         ){
         stack.push(new UndoToggleScheme(
         caret, (Sketch)s, s.parent.body.indexOf(s)));
         ((Sketch)s).open();
         res = true;
         break L12;
         }
         }
       stack.push(new UndoToggleScheme(s));
       s.type = newType;
       }
     return(
     res
     );
     }
    public void incrementArrow(Arrow ar, int k)
     {
     stack.push(new UndoIncrementArrow(ar, k));
     redoStack.setEmpty();
     ar.level -= k;
      L13:
       {
         {
         if(
         (ar.type == Arrow.STRONG)
         ){
         ar.type = Arrow.WEAK;
         break L13;
         }
         }
       ar.type = Arrow.STRONG;
       }
     }
    public Sketch group2simple(Selection sel)
     {
     Rectangle rE = sel.area();
     redoStack.setEmpty();
     Sketch res = sel.convert2simple(0,0);
     BaseLanguage bl =
     BaseLanguage.newBaseLanguage(res.parent.baseLanguage.type);
     res.baseLanguage = bl;
     bl =
     BaseLanguage.newBaseLanguage(res.parent.baseLanguage.type);
     Branch br = (Branch)(res.member(0));
     br.baseLanguage = bl;
     View.set(res, res.parent.view.type);
     View.set(br, res.parent.view.type);
       {
       if(
       (caret.row != null) &&
       (rE.contains(caret.row.x, caret.row.y))&&
       (res.parent == caret.scheme)
       ){
       caret.scheme = res.branch(0);
       }
       }
     stack.push(new UndoGroup2simple(res));
     return(
     res
     );
     }
    public Sketch encloseOuter(Sketch sk)
     {
     stack.push(new UndoEncloseOuter(sk, caret));
     redoStack.setEmpty();
     Sketch newOuter = new Sketch(Scheme.SIMPLE,
     new Branch(Scheme.SIMPLE, null),null);
     Branch br = newOuter.branch(0);
     br.add(sk); br.removeMember(0);
     BaseLanguage bl =
     BaseLanguage.newBaseLanguage(sk.baseLanguage.type);
     newOuter.baseLanguage = bl;
     bl =
     BaseLanguage.newBaseLanguage(sk.baseLanguage.type);
     br.baseLanguage = bl;
     View.set(newOuter, sk.view.type);
     View.set(br, sk.view.type);
     sk.incrementArrows(2);
     sketchyText.main = newOuter;
     sketchyText.affected = newOuter;
     caret.goTo(newOuter);
     return(
     newOuter
     );
     }
    public void undo()
     {
     sketchyText.frame.viewArea.selection.cancel();
     isRedoing = false;
     stack.pop().undo(this);
     isRedoing = true;
     }
    public void redo()
     {
     sketchyText.frame.viewArea.selection.cancel();
     isRedoing = true;
     redoStack.pop().undo(this);
     isRedoing = false;
     }
   }
