 import java.util.*;
  abstract class Scheme
   {
   static final byte SIMPLE = 0;
   static final byte LOOP = 1;
   static final byte MODULE = 2;
   byte type;
   Vector head;
   Vector body;
   Row comment;
   BaseLanguage baseLanguage;
   View view;
   boolean icon;
   transient Scheme parent;
   abstract void removeMember(int i);
   abstract int level();
   abstract void insert(PrimitiveMember pm, int i);
   abstract void insert(Sketch sk, int i);
   abstract void insert(Branch br, int i);
    Scheme(byte t, BaseLanguage bl)
     {
     type = t; head = new Vector(); body = new Vector();
     baseLanguage = bl; comment = new Row(Default.commentColor);
     view = new ViewSketchy(this);
     icon = false;
     }
    void remove()
     {
       {
       if(
       (parent != null)
       ){
       parent.body.removeElement(this);
       }
       }
     }
    boolean isHeadless()
     {
     return(
     head.size() == 0
     );
     }
    boolean hasLeavingArrows(int piir)
     {
      L0:
      for(
      int i = 0; i < body.size(); i++
      )
       {
       Object o = member(i);
         {
         if(
         o instanceof Arrow
         ){
           {
           if(
           ((Arrow)o).level < piir 
           ){
           return(
            true
           );
           }
           }
         continue L0;
         }
         }
       if(
       o instanceof Scheme
       ){
         {
         if(
         ((Scheme)o).hasLeavingArrows(piir)
         ){
         return(
         true
         );
         }
         }
       }
       }
     return(
     false
     );
     }
    void correctLeavingArrows()
     {
      L1:
      for(
      int i = 0; i < body.size(); i++
      )
       {
       Object o = member(i);
         {
         if(
         o instanceof Arrow
         ){
           {
           Arrow ar = (Arrow)o;
           if(
           ar.level < 0 
           ){
           ar.level = 0;
           ar.type = Arrow.STRONG;
           }
           }
         continue L1;
         }
         }
         {
         if(
         o instanceof Scheme
         ){
         ((Scheme)o).correctLeavingArrows();
         }
         }
       }
     }
    PrimitiveHead primitiveHead(int i)
     {
     return(
     (PrimitiveHead)(head.elementAt(i))
     );
     }
    void insert(PrimitiveHead h, int i)
     {
     head.insertElementAt(h, i);
     }
    void add(PrimitiveHead h)
     {
     insert(h, head.size());
     }
    void removePrimitiveHead(int i)
     {
     head.removeElementAt(i);
     }
    Object member(int i)
     {
     return(
     body.elementAt(i)
     );
     }
    void invalidate(int till)
     {
       {
       if(
       ( view.x >= till)
       ){
       return;
       }
       }
     comment.invalidate();
     int i;
      for(
      i = 0; i < head.size(); i++
      )
       {
       (primitiveHead(i).text).invalidate();
       }
      L2:
      for(
      i = 0; i < body.size(); i++
      )
       {
       Object o = member(i);
         {
         if(
         (o instanceof Primitive)
         ){
         (((Primitive)o).text).invalidate();
         continue L2;
         }
         }
       ((Scheme)o).invalidate(till);
       }
     }
    void invalidateRest(int from)
     {
       {
       if(
       ( (view.y + view.height) < from)
       ){
       return;
       }
       }
       {
       if(
       (comment.y >= from)
       ){
       comment.invalidate();
       }
       }
     int i;
      for(
      i = 0; i < head.size(); i++
      )
       {
       if(
       (primitiveHead(i).text.y >= from)
       ){
       (primitiveHead(i).text).invalidate();
       }
       }
      L3:
      for(
      i = 0; i < body.size(); i++
      )
       {
       Object o = member(i);
         {
         if(
         (o instanceof Primitive)
         ){
         Primitive p = (Primitive)o;
           {
           if(
           (p.text.y >= from)
           ){
           p.text.invalidate();
           }
           }
         continue L3;
         }
         }
       ((Scheme)o).invalidateRest(from);
       }
     }
    void invalidate(int from, int till)
     {
       {
       if(
       ((view.y + view.height) < from)
       ){
       return;
       }
       }
       {
       if(
       (view.y > till)
       ){
       return;
       }
       }
     if(
     (((view.y + view.height) <= till) &&
     (view.y >= from))
     ){
     invalidateRest(0);
       {
       if(
       ((comment.y >= from) && (comment.y <= till))
       ){
       comment.invalidate();
       }
       }
     int i;
     int yy;
      for(
      i = 0; i < head.size(); i++
      )
       {
       yy = primitiveHead(i).text.y;
         {
         if(
         (yy > till)
         ){
         return;
         }
         }
       if(
       (yy >= from)
       ){
       (primitiveHead(i).text).invalidate();
       }
       }
      L4:
      for(
      i = 0; i < body.size(); i++
      )
       {
       Object o = member(i);
         {
         if(
         (o instanceof Primitive)
         ){
         Primitive p = (Primitive)o;
         yy = p.text.y;
           {
           if(
           (yy > till)
           ){
           return;
           }
           }
           {
           if(
           (yy >= from)
           ){
           p.text.invalidate();
           }
           }
         continue L4;
         }
         }
       ((Scheme)o).invalidate(from, till);
       }
     }
     }
   }
