 import java.util.*;
  class Sketch extends Scheme
   {
    Sketch(byte t, Branch br, BaseLanguage bl)
     {
     super(t, bl);
     parent = null;
     insert(br, 0);
     }
    Sketch(byte t,  BaseLanguage bl)
     {
     super(t, bl);
     parent = null;
     }
    void insert(PrimitiveMember pm, int i)
     {
     System.out.println
     ("Sketch: illegal attempt to insert primitive member!");
     System.exit(0);
     }
    void insert(Sketch sk, int i)
     {
     System.out.println
     ("Sketch: illegal attempt to insert subsketch!");
     System.exit(0);
     }
    void insert(Branch br, int i)
     {
     br.parent = this;
     body.insertElementAt(br, i);
     }
    void add(Branch br)
     {
     insert(br, body.size());
     if(
     body.size() == 2
     ){
     if(
     branch(0).body.size() == 0
     ){
     removeMember(0);
     }
     }
     }
    void removeMember(int i)
     {
       {
       if(
       (isMono())
       ){
       System.out.println
       ("Sketch: illegal attempt to remove the single branch!");
       System.exit(0);
       }
       }
     body.removeElementAt(i);
     }
    int level()
     {
       {
       if(
       (parent == null)
       ){
       return(
       0
       );
       }
       }
     return(
     parent.level() + 1
     );
     }
    boolean isMono()
     {
     return(
     body.size() == 1
     );
     }
    Branch branch(int i)
     {
     return(
     (Branch)(body.elementAt(i))
     );
     }
    boolean isSimpleMono()
     {
       {
       if(
       (type != Scheme.SIMPLE)
       ){
       return(
       false
       );
       }
       }
       {
       if(
       (head.size() != 0)
       ){
       return(
       false
       );
       }
       }
       {
       if(
       (body.size() != 1)
       ){
       return(
       false
       );
       }
       }
       {
       if(
       (branch(0).type != Scheme.SIMPLE)
       ){
       return(
       false
       );
       }
       }
       {
       if(
       (branch(0).head.size() != 0)
       ){
       return(
       false
       );
       }
       }
     return(
     true
     );
     }
    boolean isAllMono()
     {
       {
       if(
       !isMono()
       ){
       return(
       false
       );
       }
       }
     Branch br = branch(0);
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
       if(
       (o instanceof Sketch) && (!((Sketch)o).isAllMono())
       ){
       return(
       false
       );
       }
       }
     return(
     true
     );
     }
    boolean isPlainText()
     {
       {
       if(
       (!isSimpleMono())
       ){
       return(
       false
       );
       }
       }
     Branch br = branch(0);
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
         {
         if(
         (o instanceof Scheme)
         ){
         return(
         false
         );
         }
         }
       PrimitiveMember p = (PrimitiveMember)o;
         {
         if(
         (p.type != Primitive.SIMPLE)
         ){
         return(
         false
         );
         }
         }
         {
         if(
         (p.text.rows.size() != 1)
         ){
         return(
         false
         );
         }
         }
       if(
       (p.text.comment.elements.size() != 1)
       ){
       return(
       false
       );
       }
       }
     return(
     true
     );
     }
    boolean isRichModel()
     {
       {
       if(
       comment.isRichModel()
       ){
       return(
       true
       );
       }
       }
      for(
      int j = 0, m = head.size(); j < m;  j++
      )
       {
       if(
       primitiveHead(j).isRichModel()
       ){
       return(
       true
       );
       }
       }
      for(
      int i = 0, n = body.size(); i < n; i++
      )
       {
       if(
       branch(i).isRichModel()
       ){
       return(
       true
       );
       }
       }
     return(
     false
     );
     }
    Sketch makeCopy()
     {
     Sketch res = makeCopyRecurs();
     res.incrementArrows(-level());
     return(
     res
     );
     }
    Sketch makeCopyRecurs()
     {
     Sketch res = new Sketch((byte)0, new Branch((byte)0, null), null);
     res.type = type;
      for(
      int i=0; i < head.size(); i++
      )
       {
       PrimitiveHead h = primitiveHead(i);
       res.insert(h.makeCopy(), i);
       }
      for(
      int i=0; i < body.size(); i++
      )
       {
       Branch br = branch(i).makeCopyRecurs();
       br.parent = res;
       res.insert(br, i+1);
       }
     res.removeMember(0);
     res.baseLanguage =
     BaseLanguage.newBaseLanguage(baseLanguage.type);
     res.comment = comment.makeCopy();
     res.parent = null;
     View.set(res, view.type);
     res.icon = icon;
     return(
     res
     );
     }
    void open()
     {
     incrementArrows(level(), -1);
     int no = parent.body.indexOf(this);
     parent.body.removeElementAt(no);
     Branch br = (Branch)(member(0));
      L0:
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o = br.member(i);
         {
         if(
         (o instanceof Sketch)
         ){
         ((Sketch)o).parent = br;
         parent.insert((Sketch)o, no++);
         continue L0;
         }
         }
         {
         if(
         (o instanceof Arrow)
         ){
         Arrow ar = (Arrow)o;
         parent.insert(ar, no++);
         continue L0;
         }
         }
       parent.insert((PrimitiveMember)o, no++);
       }
     }
    public boolean containsArrow(int l)
     {
      for(
      Enumeration ee = body.elements(); ee.hasMoreElements();
      )
       {
       Branch br = (Branch)(ee.nextElement());
        L1:
        for(
        Enumeration e = br.body.elements(); e.hasMoreElements();
        )
         {
         Object o = e.nextElement();
           {
           if(
           (o instanceof Arrow)
           ){
           Arrow ar = (Arrow)o;
             {
             if(
             (ar.level == l)
             ){
             return(
             true
             );
             }
             }
           continue L1;
           }
           }
         if(
         (o instanceof Sketch)
         ){
         if(
         (((Sketch)o).containsArrow(l))
         ){
         return(
         true
         );
         }
         }
         }
       }
     return(
     false
     );
     }
    public boolean containsSubsketch(int l)
     {
      for(
      Enumeration ee = body.elements(); ee.hasMoreElements();
      )
       {
       Branch br = (Branch)(ee.nextElement());
        for(
        Enumeration e = br.body.elements(); e.hasMoreElements();
        )
         {
         Object o = e.nextElement();
         if(
         (o instanceof Sketch)
         ){
         return(
         true
         );
         }
         }
       }
     return(
     false
     );
     }
    public void incrementArrows(int l, int n)
     {
      for(
      Enumeration ee = body.elements(); ee.hasMoreElements();
      )
       {
       Branch br = (Branch)(ee.nextElement());
        L2:
        for(
        Enumeration e = br.body.elements(); e.hasMoreElements();
        )
         {
         Object o = e.nextElement();
           {
           if(
           (o instanceof Arrow)
           ){
           Arrow ar = (Arrow)o;
             {
             if(
             (ar.level >= l)
             ){
             ar.level += 2*n;
             }
             }
           continue L2;
           }
           }
         if(
         (o instanceof Sketch)
         ){
         ((Sketch)o).incrementArrows(l, n);
         }
         }
       }
     }
    public void incrementArrows(int incr)
     {
      for(
      Enumeration ee = body.elements(); ee.hasMoreElements();
      )
       {
       Branch br = (Branch)(ee.nextElement());
        L3:
        for(
        Enumeration e = br.body.elements(); e.hasMoreElements();
        )
         {
         Object o = e.nextElement();
           {
           if(
           (o instanceof Arrow)
           ){
           Arrow ar = (Arrow)o;
           ar.level += incr;
           ar.adjustType();
           continue L3;
           }
           }
         if(
         (o instanceof Sketch)
         ){
         ((Sketch)o).incrementArrows(incr);
         }
         }
       }
     }
    public void withdrawArrows(int level)
     {
      for(
      Enumeration ee = body.elements(); ee.hasMoreElements();
      )
       {
       Branch br = (Branch)(ee.nextElement());
        L4:
        for(
        Enumeration e = br.body.elements(); e.hasMoreElements();
        )
         {
         Object o = e.nextElement();
           {
           if(
           (o instanceof Arrow)
           ){
           Arrow ar = (Arrow)o;
             {
             if(
             (ar.level == level)
             ){
             ar.level--;
             ar.type = Arrow.WEAK;
             }
             }
           continue L4;
           }
           }
         if(
         (o instanceof Sketch)
         ){
         ((Sketch)o).withdrawArrows(level);
         }
         }
       }
     }
   }
