import java.io.*;
import java.util.*;

/**
 * Tehakse Skeemist HTML-plain fail 
 *
 *@author Martin Vels & J.Kiho
 */


class Sketch2HtmlPlain {

    static final String TITLE = "<HTML><BODY>AMADEUS html plain";

  static PrintWriter out;  // globaalne muutuja faili kirjutamiseks
    // kas reavahetus no~utud:
    static boolean lastNotEmptyText = false;
  // Konstruktor
  //public AmSketch2HTML () { // doin' nothin'
  //}

  // Kirjutame etteantud stringi faili
  static void write2file (String buf) {
    out.println(buf);
//    System.out.println(buf);
  } // write2file

  // Kirjutab faili html-i headeri
  static void writeHeader(String title) {
    write2file("<!--- This file is generated by AMADEUS. --->");
    write2file(TITLE);
  }

  // Lotilde;petame html-i korralikult auml;ra ka
  static void writeFooter() {
    write2file("</BODY>");
    write2file("</HTML>");
  }



  // Kirjutatakse faili lihtliige
  static void writePrimitiveMember(PrimitiveMember p) {
    // lihtliikme algus
    write2file("<!"+str((int)(p.type))+">");
    // primtiivi text
    
    switch (p.type){
      case Primitive.SIMPLE:
        writeText(p.text, "&nbsp;&nbsp;&nbsp;");
      break;
      case Primitive.CONDITION:
        writeText(p.text, "&nbsp;?&nbsp;");
      break;
    }
    lastNotEmptyText = true;
  }
  
  static void writeText(Text t, String st0){
    if(lastNotEmptyText) write2file("<!br><br>");
    // st0 - esimese rea algusse
    write2file(st0+"<!X>" + t.row(0).toString());
    for(int i = 1; i < t.rows.size(); i++)
	write2file("<br>" + t.row(i).toString());
    // kommentaar
    write2file("<i>" + t.comment.toString() + "</i>");
  }
  static void writeArrowText(Text t, String st0, String st1){
  //  if(lastNotEmptyText) write2file("<!br><br>");
    // st0 - esimese rea algusse
    // st1 = endlevel+100(3sy) - kommentaari algusse lisaks
    write2file(st0 + t.row(0).toString());
    for(int i = 1; i < t.rows.size(); i++)
	write2file("<br>" + t.row(i).toString());
    // kommentaar
    write2file("<i><!"+st1+">"+t.comment.toString()+"</i>");
    
    lastNotEmptyText = false;
  }

  // Kirjutame AmArrow-tyypi objekti faili
  static void writeArrow(Arrow a, int startLevel) {
    // noole algus
    int level = a.level; // otsatase
    // redutseerida pseudo
    if(level < 0) level = -199;  // seega kood: -99. Dekod: -199 
    else if(level > 899) level = 899;// seega kood: 999.Dekod:899
    
    write2file("<!"+str((int)(a.type))+">");
  
    int i;
    int len = startLevel - level; // noole pikkus
    for(i = 0; i <= len/2; i++)
	write2file("</ul>"); 
    
    // noole kujutis
    StringBuffer stb = new StringBuffer();
    stb.append("&nbsp;");
    String c;
    if(a.type == Arrow.STRONG) c = "="; else c = "-";
    stb.append("<");
    stb.append(c);
    stb.append(c);
   // stb.append(c);
   // stb.append(c);
    for(i = 0; i <= len/2; i++){ 
	stb.append(c);
	stb.append(c);
	 stb.append(c);
	 stb.append(c);
    }
    stb.append("<!X>");
    // noole tekst 
    
    writeArrowText(a.text, stb.toString(), str(level+100));	
	
    // noole lo~pp
     for(i = 0; i <= len/2; i++)
	write2file("<ul>");
	
    lastNotEmptyText = true; 	
  }


  // Kirjutame pauml;ise faili
  static void writeHead(Scheme s) {
    int n = s.head.size();
    lastNotEmptyText = false; // nagunii oli <UL> voi tuleb haru
	
    for(int i = 0; i < n; i++){
	PrimitiveHead he = s.primitiveHead(i);
	// lihtpa"ise algus
        String st = str((int)(he.type));
	write2file("<!"+st+">");
	 
	// lihtpa"ise tekst
    
	switch (he.type){
	case PrimitiveHead.SIMPLE:
	    writeText(he.text, "&nbsp;&nbsp;&nbsp;");
	    break;
	case PrimitiveHead.LOOP:
	    writeText(he.text, "&nbsp;*&nbsp;");
	    break;
	case PrimitiveHead.SWITCH:
	    writeText(he.text, "&nbsp;??");
	    break;
	case PrimitiveHead.TRY:
	    writeText(he.text, "&nbsp;!!");
	    break;
	case PrimitiveHead.CASE:
	case PrimitiveHead.DEFAULT:
	    writeText(he.text, "&nbsp;?&nbsp;");
	    break;
	case PrimitiveHead.CATCH:
	    writeText(he.text, "&nbsp;!&nbsp;");
	    break;
	}//switch
    }//for
    lastNotEmptyText = true;
  }


  // See meetod tegeleb skeemi labivaatamise ja faili
  // kirjutamisega
  static void writeScheme(Scheme s) {
    Object o;
    // skeemi algust tauml;histab  <! tyyp bl view icon>
    String type = str((int)(s.type));
    String bl = str((int)(s.baseLanguage.type));
    //String view = str((int)(s.view.type()));
    String view = str((int)(s.view.type));
    String icon;
    if(s.icon) icon = "1"; else icon = "0";
    write2file("<!"+type+bl+view+icon+">");
    // joon vahele
    String line = "<HR size = "+str((int)(2*s.type))+">";
    write2file(line);
    String comm = s.comment.toString();
    write2file("<I>" + comm + "</I>");
    if(comm.length() > 0)
	lastNotEmptyText = true;
    else
	lastNotEmptyText = false;
    // Kirjutame  paise
    writeHead(s);
    // skeemi keha algus
    if(s instanceof Branch) write2file("<UL>");  
    for (Enumeration e = s.body.elements(); e.hasMoreElements(); ){
	o = e.nextElement();

	if (o instanceof Scheme) // tegemist skeemiga
	    writeScheme((Scheme)o);
	else if(o instanceof Arrow)
	    writeArrow((Arrow)o, s.level());
	else
	    writePrimitiveMember((PrimitiveMember)o);
	    
    }
    // skeemi lo~pp
    if(s instanceof Branch) 
	write2file("</UL>");  // haru keha l6putunnus
    else
	write2file(line); // skeemi lo~pujoon <HR ..
    write2file("<!xxxx>");
    
    lastNotEmptyText = false;

  }
  
  // abiks
  static private String str(int n){
    return (new Integer(n)).toString(); 
  }
  
  // Votilde;tame vastu 2 parameetrit: AmSketchi ja faili nime
  // parameetriteks olgu sketch ja failinimi kuhu ta HTML-iseerida.
  static public void s2h (Scheme s, String fname) {

    // Avame etteantud nimelise faili
    try {
      out = new PrintWriter(new FileWriter(fname));
    }
    // pyyame exceptioni kui ei 6nnestunud faili luua
    catch (IOException e) {
      System.err.println("Caught IOException: " + e.getMessage());
    }

    writeHeader(TITLE);
    writeScheme(s);
    writeFooter();

    // fail kinni
    out.close();
  }
} // AmSketch2HTML
