 import java.io.*;
 import java.util.*;
  class Sketch2TexPlain
   {
   static final int MAX_ONELINE = 80;
   static String resultString = null;
   static PrintWriter out;
    static void write2file (String buf)
     {
     out.println(buf);
     }
    static void writeHeader()
     {
     write2file("%This file is generated by AMADEUS.");
     write2file("%\\input amadeus.tex");
     write2file("{\\scheme ");
     }
    static void writeFooter()
     {
     write2file("}");
     write2file("%\\bye");
     }
    static void writeText(Text t, boolean comm)
     {
     int n = t.rows.size();
      for(
      int i = 0; i < n-1; i++
      )
       {
       write2file(t.row(i).toString());
       }
      L0:
       {
         {
         if(
         comm
         ){
         write2file(t.row(n-1).toString() +"}{");
         write2file(t.comment.toString() +"}");
         break L0;
         }
         }
       write2file(t.row(n-1).toString() +"}");
       }
     }
    static void writePrimitiveMember(Primitive p)
     {
     boolean comm = !p.text.comment.isTrivial();
      L2:
       {
         {
         if(
         p.type ==  Primitive.SIMPLE
         ){
          L1:
           {
             {
             if(
             comm
             ){
             write2file("\\primitivec{");
             break L1;
             }
             }
           write2file("\\primitive{");
           }
         break L2;
         }
         }
         {
         if(
         p.type ==  Primitive.CONDITION
         ){
          L3:
           {
             {
             if(
             comm
             ){
             write2file("\\conditionc{");
             break L3;
             }
             }
           write2file("\\condition{");
           }
         break L2;
         }
         }
       resultString =
       AmLocale.Illegal()+" "+AmLocale.primitive_type();
       return;
       }
     writeText(p.text, comm);
     }
    static void writeArrow(Arrow ar, int lev)
     {
     boolean comm = !ar.text.comment.isTrivial();
     PrimitiveMember p = new PrimitiveMember(Primitive.SIMPLE,
     ar.text);
     int len = (lev - ar.level)/2;
     char suffix = (char)('B' + len);
      L4:
       {
         {
         if(
         ar.type == Arrow.STRONG
         ){
         write2file("\\arrow{\\len"+suffix+"}{");
         writePrimitiveMember(p);
         break L4;
         }
         }
       write2file("\\weakarrow{\\wlen"+suffix+"}"
       +"{\\wshift"+suffix+"}{");
       writePrimitiveMember(p);
       }
     write2file("}");
     }
    static void writeHead(Scheme s)
     {
     int n = s.head.size();
       {
       if(
       n == 0
       ){
       write2file("}{");
       return;
       }
       }
      for(
      int i = 0; i < n; i++
      )
       {
       PrimitiveHead he = s.primitiveHead(i);
       boolean comm = !he.text.comment.isTrivial();
        switch(
        he.type
        )
        {
         case
          PrimitiveHead.SIMPLE:
          L5:
           {
             {
             if(
             comm
             ){
             write2file("\\simpleheadc{");
             break L5;
             }
             }
           write2file("\\simplehead{");
           }
         break;
         case
          PrimitiveHead.LOOP:
          L6:
           {
             {
             if(
             comm
             ){
             write2file("\\loopheadc{");
             break L6;
             }
             }
           write2file("\\loophead{");
           }
         break;
         case
          PrimitiveHead.TRY:
          L7:
           {
             {
             if(
             comm
             ){
             write2file("\\tryheadc{");
             break L7;
             }
             }
           write2file("\\tryhead{");
           }
         break;
         case
          PrimitiveHead.CATCH:
          L8:
           {
             {
             if(
             comm
             ){
             write2file("\\catchheadc{");
             break L8;
             }
             }
           write2file("\\catchhead{");
           }
         break;
         case
          PrimitiveHead.SWITCH:
          L9:
           {
             {
             if(
             comm
             ){
             write2file("\\switchheadc{");
             break L9;
             }
             }
           write2file("\\switchhead{");
           }
         break;
         case
          PrimitiveHead.CASE:
         case
          PrimitiveHead.DEFAULT:
          L10:
           {
             {
             if(
             comm
             ){
             write2file("\\caseheadc{");
             break L10;
             }
             }
           write2file("\\casehead{");
           }
         break;
         default
         :
         {
         resultString =
         AmLocale.Illegal()+" "+AmLocale.head_type();
         return;
         }
        }
       writeText(he.text, comm);
       }
     write2file("}{");
     }
    static void write(Sketch s)
     {
       {
       if(
       resultString != null
       ){
       return;
       }
       }
     Object o;
       {
       if(
       s.icon
       ){
       String comm = s.comment.toString().trim();
         {
         if(
         comm.length() == 0
         ){
         if(
         !s.isHeadless()
         ){
         comm = s.primitiveHead(0).text.toString();
         }
         }
         }
       write2file("\\sketchicon{"+comm+"}");
       return;
       }
       }
     Branch br0 = s.branch(0);
      L14:
       {
         {
         if(
         ((s.head.size() == 0)
         && (s.body.size() == 1)
         && (br0.head.size() == 0)
         &&  (br0.comment.isTrivial())
         && (!br0.icon)
         )
         ){
           {
           if(
           s.type == Scheme.SIMPLE
           ){
           if(
           br0.body.size() == 2
           ){
           o = br0.member(0);
           if(
           o instanceof PrimitiveMember
           ){
           PrimitiveMember p0 = (PrimitiveMember)o;
           if(
           ((p0.type == Primitive.CONDITION)
           && p0.text.comment.isTrivial()
           && (p0.text.rows.size() == 1))
           ){
           o = br0.member(1);
           if(
           o instanceof PrimitiveMember
           ){
           PrimitiveMember p1 = (PrimitiveMember)o;
           if(
           ((p1.type == Primitive.SIMPLE)
           && p1.text.comment.isTrivial()
           && (p1.text.rows.size() == 1))
           ){
           String scom = s.comment.toString();
           String cond = p0.text.row(0).toString();
           String row1 = p1.text.row(0).toString();
           if(
           (scom.length()+
           cond.length()+row1.length()
           < MAX_ONELINE)
           ){
            L11:
             {
               {
               if(
               scom.length() == 0
               ){
               write2file(
               "\\onelinecond{"+cond+"}{"+row1+"}");
               break L11;
               }
               }
             write2file(
             "\\onelinecondc{"+scom+"}{"+cond+"}{"+row1+"}");
             }
           return;
           }
           }
           }
           }
           }
           }
           }
           }
           {
           if(
           (s.type == Scheme.SIMPLE)
           ){
           if(
           (br0.body.size() == 4)
           ){
           o = br0.member(0);
           if(
           (o instanceof PrimitiveMember)
           ){
           PrimitiveMember p0 = (PrimitiveMember)o;
           if(
           ((p0.type == Primitive.CONDITION)
           && p0.text.comment.isTrivial()
           && (p0.text.rows.size() == 1))
           ){
           o = br0.member(1);
           if(
           (o instanceof PrimitiveMember)
           ){
           PrimitiveMember p1 = (PrimitiveMember)o;
           if(
           ((p1.type == Primitive.SIMPLE)
           && p1.text.comment.isTrivial()
           && (p1.text.rows.size() == 1))
           ){
           o = br0.member(2);
           if(
           ((o instanceof Arrow)
           &&(s.level() == ((Arrow)o).level)
           &&(((Arrow)o).text.isTrivial())
           &&(((Arrow)o).text.comment.isTrivial())
           )
           ){
           o = br0.member(3);
           if(
           (o instanceof PrimitiveMember)
           ){
           PrimitiveMember  p3 = (PrimitiveMember)o;
           if(
           ((p3.type == Primitive.SIMPLE)
           && p3.text.comment.isTrivial()
           && (p3.text.rows.size() == 1))
           ){
           String scom = s.comment.toString();
           String cond = p0.text.row(0).toString();
           String row1 = p1.text.row(0).toString();
           String row3 = p3.text.row(0).toString();
           if(
           (scom.length()+
           cond.length()+row1.length() + row3.length()
           < MAX_ONELINE)
           ){
            L12:
             {
               {
               if(
               (scom.length() == 0)
               ){
               write2file(
               "\\onelinecondelse{"+cond+"}{"+row1+"}{"+row3+"}");
               break L12;
               }
               }
             write2file(
             "\\onelinecondelsec{"+scom+"}{"+cond+"}{"+row1+"}{"+row3+"}");
             }
           return;
           }
           }
           }
           }
           }
           }
           }
           }
           }
           }
           }
          switch(
          s.type
          )
          {
           case
            Scheme.SIMPLE:
           write2file("\\simplesketch{");
           break;
           case
            Scheme.LOOP:
           write2file("\\loopsketch{");
           break;
           case
            Scheme.MODULE:
           write2file("\\modulesketch{");
           break;
           default
           :
           {
           resultString = AmLocale.Illegal() +" "
           + AmLocale.scheme_type() +".";
           return;
           }
          }
         String comm = s.comment.toString();
         write2file(comm + "}{");
         Branch br = s.branch(0);
          for(
           Enumeration e = br.body.elements(); e.hasMoreElements(); 
          )
           {
           o = e.nextElement();
            L13:
             {
               {
               if(
               (o instanceof Sketch)
               ){
               write((Sketch)o);
               break L13;
               }
               }
               {
               if(
               (o instanceof Arrow)
               ){
               writeArrow((Arrow)o, br.level());
               break L13;
               }
               }
             writePrimitiveMember((PrimitiveMember)o);
             }
           if(
           (resultString != null)
           ){
           return;
           }
           }
         write2file("}");
         break L14;
         }
         }
         {
         if(
         ((s.type == Scheme.LOOP)
         && (s.head.size() == 1)
         && (s.body.size() == 1))
         ){
         if(
         ((br0.body.size() == 1)&&(br0.head.size()==0))
         ){
         PrimitiveHead he = s.primitiveHead(0);
         if(
         ((he.type == PrimitiveHead.LOOP)
         && he.text.comment.isTrivial()
         && (he.text.rows.size() == 1))
         ){
         o = br0.member(0);
         if(
         (o instanceof PrimitiveMember)
         ){
         PrimitiveMember p1 = (PrimitiveMember)o;
         if(
         ((p1.type == Primitive.SIMPLE)
         && p1.text.comment.isTrivial()
         && (p1.text.rows.size() == 1))
         ){
         String scom = s.comment.toString();
         String head = he.text.row(0).toString();
         String row1 = p1.text.row(0).toString();
         if(
         (scom.length()+
         head.length()+row1.length()
         < MAX_ONELINE)
         ){
          L15:
           {
             {
             if(
             (scom.length() == 0)
             ){
             write2file(
             "\\onelineloop{"+head+"}{"+row1+"}");
             break L15;
             }
             }
           write2file(
           "\\onelineloopc{"+scom+"}{"+head+"}{"+row1+"}");
           }
         return;
         }
         }
         }
         }
         }
         }
         }
        switch(
        s.type
        )
        {
         case
          Scheme.SIMPLE:
         write2file("\\simplesketchB{");
         break;
         case
          Scheme.LOOP:
         write2file("\\loopsketchB{");
         break;
         case
          Scheme.MODULE:
         write2file("\\modulesketchB{");
         break;
         default
         :
         {
         resultString =
         AmLocale.Illegal() +" "
         + AmLocale.scheme_type() +".";
         return;
         }
        }
       String comm = s.comment.toString();
       write2file(comm + "}{");
       writeHead(s);
         {
         if(
         (resultString != null)
         ){
         return;
         }
         }
        for(
        int i = 0; i < s.body.size(); i++
        )
         {
         write(s.branch(i));
         if(
         (resultString != null)
         ){
         return;
         }
         }
       write2file("}");
       }
     }
    static void write(Branch br)
     {
       {
       if(
       (br.icon)
       ){
       String comm = br.comment.toString().trim();
         {
         if(
         (comm.length() == 0)
         ){
         if(
         (!br.isHeadless())
         ){
         comm = br.primitiveHead(0).text.toString();
         }
         }
         }
       write2file("\\branchicon{"+comm+"}");
       return;
       }
       }
      switch(
      br.type
      )
      {
       case
        Scheme.SIMPLE:
       write2file("\\simplebranch{");
       break;
       case
        Scheme.LOOP:
       write2file("\\loopbranch{");
       break;
       case
        Scheme.MODULE:
       write2file("\\modulebranch{");
       break;
       default
       :
       {
       resultString = AmLocale.Illegal() +" "
       + AmLocale.branch_type() +".";
       return;
       }
      }
     String comm = br.comment.toString();
     write2file(comm + "}{");
     writeHead(br);
       {
       if(
       (resultString != null)
       ){
       return;
       }
       }
      for(
       Enumeration e = br.body.elements(); e.hasMoreElements(); 
      )
       {
       Object o = e.nextElement();
        L16:
         {
           {
           if(
           (o instanceof Sketch)
           ){
           write((Sketch)o);
           break L16;
           }
           }
           {
           if(
           (o instanceof Arrow)
           ){
           writeArrow((Arrow)o, br.level());
           break L16;
           }
           }
         writePrimitiveMember((PrimitiveMember)o);
         }
       if(
       (resultString != null)
       ){
       return;
       }
       }
     write2file("}");
     }
    static void writeSubschemes(Sketch s)
     {
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Branch br = s.branch(i);
       LOOP:
        L17:
        for(
        int j = 0; j < br.body.size(); j++
        )
         {
         Object o = br.member(j);
           {
           if(
           (o instanceof Primitive)
           ){
           continue L17;
           }
           }
         Sketch sk = (Sketch)o;
         L:
          L18:
           {
             {
             if(
             (sk.type != Scheme.MODULE)
             ){
             break L18;
             }
             }
           String comm = sk.comment.toString();
           int l = comm.length();
             {
             if(
             (l == 0)
             ){
             break L18;
             }
             }
             {
             if(
             (comm.charAt(l-1) != '*')
             ){
             break L18;
             }
             }
             {
             if(
             (!sk.isHeadless() &&
             (sk.primitiveHead(0).type != PrimitiveHead.LOOP))
             ){
               {
               if(
               (!sk.icon)
               ){
               break L18;
               }
               }
             write2file("\\vfill \\eject");
             sk.icon = false;
             Row keep = sk.comment.makeCopy();
             sk.comment = new Row(comm.substring(
             0, comm.length()-1),
             Default.commentColor);
             write(sk);
             sk.icon = true;
             sk.comment = keep;
             continue L17;
             }
             }
           write2file("\\vskip 15pt");
           write2file(
           "--------------------------------------------"+
           "{\\bf " + comm.substring(0,l-1) + "}");
             {
             if(
             (!sk.isHeadless())
             ){
             writeHead(sk);
             }
             }
            L20:
            for(
             Enumeration e = sk.branch(0).body.elements(); e.hasMoreElements(); 
            )
             {
             o = e.nextElement();
               {
               if(
                (o instanceof Sketch)
               ){
               Sketch sub = (Sketch)o;
                L19:
                 {
                   {
                   if(
                   (!sk.icon)
                   ){
                   sub.icon = !sub.icon;
                   write(sub);
                   sub.icon = !sub.icon;
                   break L19;
                   }
                   }
                 write(sub);
                 }
               continue L20;
               }
               }
               {
               if(
               (o instanceof Arrow)
               ){
               writeArrow((Arrow)o, br.level());
               continue L20;
               }
               }
             writePrimitiveMember((PrimitiveMember)o);
             }
           continue L17;
           }
         writeSubschemes(sk);
         }
       }
     }
    static public String s2t (Sketch s, String fname)
     {
      {try
       {
       out = new PrintWriter(new FileWriter(fname));
       }
       catch
        (IOException e)
       {
       return(
       "Failed:" + e.getMessage()
       );
       }
      }
     resultString = null;
     writeHeader();
     write(s);
     writeSubschemes(s);
     writeFooter();
     out.close();
     return(
     resultString
     );
     }
   }
