 import java.io.*;
 import java.util.*;
  class Sketch2XmlPlain
   {
   static final String TITLE0 = 
   "<?xml version='1.0'?><!-- This file is generated by AMADEUS. -->";
   static final String TITLE = 
   "<!--AMADEUS xml --><!DOCTYPE SKETCHY_TEXT ";
   static final String TITLE1 = 
   "SYSTEM 'SKM_DTD_plain.dtd'>";
   static final String TITLE2 = "<SKETCHY_TEXT>";
   static PrintWriter out;
    static void write2file (String buf)
     {
     out.println(buf);
     }
    static void writeHeader(String title)
     {
     write2file(TITLE0);
     write2file(TITLE);
     write2file(TITLE1);
     write2file(TITLE2);
     }
    static void writeFooter()
     {
     write2file("</SKETCHY_TEXT>");
     }
    static void writeRowOrComment(String rida, String mrgis)
     {
      L0:
       {
         {
         if(
         rida.indexOf("<") == -1 
         ){
         if(
         rida.indexOf("&") == -1 
         ){
         write2file("<" + mrgis + ">" 
         + codeForCDATA(code(rida)) 
         + "</" + mrgis + ">");
         break L0;
         }
         }
         }
       write2file("<" + mrgis + "><![CDATA[" 
       + codeForCDATA(code(rida)) 
       + "]]></" + mrgis + ">");
       }
     }
    static void writePrimitiveMember(PrimitiveMember p, int level)
     {
      L1:
       {
         {
         if(
         level == -999
         ){
         write2file("<PRIMITIVE");
         break L1;
         }
         }
       write2file("<ARROW");
       }
       {
       if(
       p.type != 0
       ){
       write2file("type=\""+str((int)(p.type))+"\"");
       }
       }
       {
       if(
       level != -999
       ){
       write2file("level=\""+str(level)+"\"");
       }
       }
     write2file(">");
     writeText(p.text);
      L2:
       {
         {
         if(
         level == -999
         ){
         write2file("</PRIMITIVE>");
         break L2;
         }
         }
       write2file("</ARROW>");
       }
     }
    static void writeText(Text t)
     {
     write2file("<TEXT>");
     String comm = t.comment.toString();
       {
       if(
       comm.length() > 0
       ){
       writeRowOrComment(comm, "COMMENT"); 
       }
       }
      for(
      int i = 0; i < t.rows.size(); i++
      )
       {
       String rida = t.row(i).toString();
       writeRowOrComment(rida, "ROW"); 
       }
     write2file("</TEXT>");
     }
    static void writeHead(Scheme s, String mrgis)
     {
     int n = s.head.size();
      for(
      int i = 0; i < n; i++
      )
       {
       PrimitiveHead he = s.primitiveHead(i);
       write2file("<"+ mrgis + "_HEAD");
         {
         if(
         he.type != 0
         ){
         write2file("type=\""+str((int)(he.type))+"\"");
         }
         }
       write2file(">");
       writeText(he.text);
       write2file("</"+ mrgis + "_HEAD>");
       }
     }
    static void writeSchemeStart(Scheme s, String mrgis)
     {
     write2file("<" + mrgis);
       {
       if(
       s.type != Scheme.SIMPLE
       ){
       write2file("type=\"" + str((int)(s.type)) + "\""); 
       }
       }
       {
       if(
       s.icon
       ){
       write2file("icon=\"yes\""); 
       }
       }
       {
       if(
       s.view.type != View.SKETCHY
       ){
       write2file("view=\"" + str((int)(s.view.type)) + "\""); 
       }
       }
       {
       if(
       s.baseLanguage.type != BaseLanguage.NONE
       ){
       write2file("base=\"" + str((int)(s.baseLanguage.type)) + "\""); 
       }
       }
     write2file(">");
     String comm = s.comment.toString();
       {
       if(
       comm.length() > 0
       ){
       writeRowOrComment(comm, "COMMENT"); 
       }
       }
     }
    static void writeScheme(Scheme s)
     {
     String mrgis = "";
      L3:
       {
         {
         if(
         s instanceof Sketch
         ){
         mrgis = "SKETCH";
         break L3;
         }
         }
       mrgis = "BRANCH";
       }
     writeSchemeStart(s, mrgis);
     Object o;
     writeHead(s, "PRIMITIVE");
      for(
       Enumeration e = s.body.elements(); e.hasMoreElements(); 
      )
       {
       o = e.nextElement();
        L4:
         {
           {
           if(
           o instanceof Scheme
           ){
           writeScheme((Scheme)o);
           break L4;
           }
           }
           {
           if(
           o instanceof Arrow
           ){
           int level = ((Arrow)o).level;
           writePrimitiveMember((PrimitiveMember)o, level + 4);
           break L4;
           }
           }
         writePrimitiveMember((PrimitiveMember)o, -999);
         }
       }
     write2file("</" + mrgis + ">");
     }
    static private String str(int n)
     {
     return(
     (new Integer(n)).toString()
     );
     }
    static String code(String buf)
     {
     StringBuffer sbuf = new StringBuffer();
     char c;
      L5:
      for(
      int i = 0; i < buf.length(); i++
      )
       {
       c = buf.charAt(i);
         {
         if(
         ((int)c) < 128
         ){
         sbuf.append(c);
         continue L5;
         }
         }
       sbuf.append("&#");
       sbuf.append(Integer.toString((int)c));
       sbuf.append(';');
       }
     return(
     sbuf.toString()
     );
     }
    static String codeForCDATA(String buf)
     {
     StringBuffer sbuf = new StringBuffer();
     int k = 0; 
     int i = buf.length(); 
      L6:
      for(;;)
       {
       i = buf.substring(k).indexOf("]]>"); 
         {
         if(
         i == -1
         ){
         sbuf.append(buf.substring(k));
         break L6;
         }
         }
       sbuf.append(buf.substring(k, k+i));
       sbuf.append("&#93;&#93;&#62;");
       k += i + 3;
       }
     return(
     sbuf.toString()
     );
     }
    static public void s2h (Scheme s, String fname)
     {
      {try
       {
       out = new PrintWriter(new FileWriter(fname));
       }
       catch
        (IOException e)
       {
       System.err.println("Caught IOException: " + e.getMessage());
       }
      }
     writeHeader(TITLE);
     writeScheme(s);
     writeFooter();
     out.close();
     }
   }
