 import java.util.*;
 import java.awt.*;
  class ViewMTree extends View
   {
   static final int hd = 10;
   static final int vd = 5;
   static final int vstep = 2*vd;
   static Color color = Default.sketchLineColor;
   static Color colorBr = Default.branchHeadColor;
   static Color colorLine = Color.yellow;
   static int iconw;
   static int iconh;
   static int laius;
    ViewMTree(Scheme s)
     {
     super(s);
     type = View.STREE;
     }
    public Rectangle getLineArea(Scheme s)
     {
     return(
     new Rectangle(s.view.x, s.view.y, hd, s.view.height)
     );
     }
    private Rectangle getNodeArea(Scheme s)
     {
     int x = (s.view.x + s.view.x + s.view.width)/2;
       {
       if(
       s instanceof Sketch
       ){
       int z = nodeX((Sketch)s);
       if(
       z >= 0
       ){
       x = z;
       }
       }
       }
     int y = s.view.y + s.comment.height + vd;
       {
       if(
       s.icon
       ){
       return(
       new Rectangle(s.view.x, s.view.y, s.view.width, s.view.height)
       );
       }
       }
     int n = s.head.size();
       {
       if(
       n == 0
       ){
       return(
       new Rectangle(x, y, hd, hd)
       );
       }
       }
     int hh = 0;
     int ww = 0;
      for(
      int i = 0; i < n; i++
      )
       {
       PrimitiveHead he = s.primitiveHead(i);
         {
         if(
         i == 0
         ){
         x = he.text.x;
         y = he.text.y;
         }
         }
       hh += he.text.height + vd;
       int w = he.text.width;
       if(
        w > ww
       ){
       ww = w;
       }
       }
     return(
     new Rectangle(x, y, ww, hh-vd)
     );
     }
    private int nodeX(Sketch s)
     {
       {
       if(
       s.icon
       ){
       return(
       -1
       );
       }
       }
     Branch br = s.branch(0);
     Vector v = new Vector();
     int ww = hd;
      for(
      int i = 0; i < s.head.size(); i++
      )
       {
       PrimitiveHead he = s.primitiveHead(i);
       if(
       he.text.width > ww
       ){
       ww = he.text.width;
       }
       }
     int l = ww/2;
      for(
      int i = 0; i < br.body.size(); i++
      )
       {
       Object o= br.member(i);
       if(
       o instanceof Sketch
       ){
       Sketch ss = (Sketch)o;
       Rectangle rec = getNodeArea(ss);
       int x = (rec.x + rec.x + rec.width)/2;
       v.addElement(new Integer(x));
       }
       }
     int n = v.size();
     int k = n/2;
       {
       if(
       (n % 2) != 0 
       ){
       return(
       ((Integer)(v.elementAt(k))).intValue() - l
       );
       }
       }
       {
       if(
       n == 0
       ){
       return(
       -1
       );
       }
       }
     int x1 = ((Integer)(v.elementAt(k-1))).intValue() - l;
     int x2 = ((Integer)(v.elementAt(k))).intValue() - l;
     return(
     (x1 + x2)/2 
     );
     }
    private void drawSkLine(Graphics g, Scheme s)
     {
     Rectangle rk = getLineArea(s);
     int xx= rk.x, yy=rk.y,  korgus=rk.height;
     laius=rk.width;
     int xja = xx + 1;
     int xjl = xja;
     int dd = (s.comment.width == 0)? 0    :   vd;
     int yja = yy + (s.comment.height - dd) / 2;
     int yjl = yy + korgus - 3;
     Color keepColor = g.getColor();
     g.setColor(colorLine);
     //L0:
      L0:
       {
         {
         if(
         s instanceof Branch
         ){
         int vahe1 = laius/4;
           {
           if(
           vahe1 < 1
           ){
           vahe1 = 1;
           }
           }
           {
           if(
           s.parent.type == Scheme.MODULE
           ){
           vahe1 = 1;
           }
           }
           {
           if(
           s.parent.type == Scheme.SIMPLE
           ){
           vahe1 = 0;
           }
           }
         int xsa = xja + vahe1;
           {
           if(
           (!(((Sketch)(s.parent)).isMono())) ||
           (((Sketch)(s.parent)).head.size() > 0) ||
           (s.type != Scheme.SIMPLE)
           ){
            switch(
            s.type
            )
            {
             case
             Scheme.LOOP:
             case
             Scheme.MODULE:
             int vahe = laius/4;
               {
               if(
               vahe < 1
               ){
               vahe = 1;
               }
               }
               {
               if(
               s.type == Scheme.MODULE
               ){
               vahe = 1;
               }
               }
             int xva, yva;
             int ysa;
             xva = xja; yva = yja-vahe;
             ysa = yva + vahe;
             g.drawLine(xsa, yva, xva + laius - 2, yva);
             g.drawLine(xsa, ysa, xva + laius - 2, ysa);
             break;
             default
             :
             {
             g.drawLine(xsa, yja, xja + laius - 2 - 1, yja);
             break;
             }
            }
           }
           }
         break L0;
         }
         }
        switch(
        s.type
        )
        {
         case
         Scheme.LOOP:
         case
         Scheme.MODULE:
         int vahe = laius/4;
           {
           if(
           vahe < 1
           ){
           vahe = 1;
           }
           }
           {
           if(
           s.type == Scheme.MODULE
           ){
           vahe = 1;
           }
           }
         int xva, yva, xvl, yvl;
         int xsa, ysa, xsl, ysl;
         xva = xja; yva = yja-vahe; xvl = xjl; yvl =yjl+vahe;
         xsa = xva + vahe; ysa = yva + vahe; xsl = xsa; ysl = yvl - vahe;
         g.drawLine(xva, yva, xvl, yvl);
         g.drawLine(xva+1, yva, xva + laius - 2, yva);
         g.drawLine(xvl+1, yvl, xvl + laius - 2, yvl);
         g.drawLine(xsa, ysa, xsl, ysl);
         g.drawLine(xsa+1, ysa, xva + laius - 2, ysa);
         g.drawLine(xsl+1, ysl, xvl + laius - 2, ysl);
         break;
         default
         :
         {
         g.drawLine(xja, yja, xjl, yjl);
         g.drawLine(xja+1, yja, xja + laius - 2, yja);
         g.drawLine(xjl+1, yjl, xjl + laius - 2, yjl);
         break;
         }
        }
       }
     g.setColor(keepColor);
     }
    public void plan(int x0, int y0)
     {
     PrimitiveHead h;
     PrimitiveMember nsk;
     Arrow ar;
       {
       if(
       sk.icon
       ){
       x = x0; 
       y = y0 + sk.comment.height +vd;
       iconw = sk.comment.height;
       iconh = iconw;
       width = iconw + 8;
       height = iconh + 4;
       return;
       }
       }
     Rectangle rc = getNodeArea(sk);
     int hhe = rc.height;
     hhe += sk.comment.height;
     int ww = rc.width;
       {
       if(
       sk.comment.width > ww
       ){
       ww = sk.comment.width;
       }
       }
     int xCurr = x0;
     int yy= y0+hhe+vstep;
     int hh = 0;
      L2:
      for(
      int i = 0; i < sk.body.size(); i++
      )
       {
       Object o = sk.member(i);
         {
         if(
         o instanceof Scheme
         ){
         Scheme ss = (Scheme)o;
          L1:
           {
             {
             if(
             ss instanceof Sketch
             ){
             ss.view.plan(xCurr+hd, yy);
             xCurr += ss.view.width + hd;
               {
               if(
               ss.view.height > hh
               ){
               hh = ss.view.height;
               }
               }
             break L1;
             }
             }
           ss.view.plan(xCurr+1, yy - vstep);
           xCurr += ss.view.width+hd;
           if(
           ss.view.height > hh
           ){
           hh = ss.view.height;
           }
           }
         continue L2;
         }
         }
       PrimitiveMember ns = (PrimitiveMember)o;
       ns.text.plan(xCurr+hd, yy);
       }
     sk.comment.plan(sk.comment.x, sk.comment.y);
     width = xCurr - x0 + 1;
     width = Math.max(Math.max(sk.comment.width, rc.width), width);
     int xNode =  (x0 + x0 + width)/2 - rc.width/2;
       {
       if(
       sk instanceof Sketch
       ){
       int z = nodeX((Sketch)sk);
       if(
       z >= 0
       ){
       xNode = z;
       }
       }
       }
     xNode = Math.max(xNode, x0);
     sk.comment.x = xNode;
     sk.comment.y = y0;
     yy = sk.comment.y + sk.comment.height +vd;
       {
       if(
       sk.head.size() != 0
       ){
        for(
        Enumeration e = sk.head.elements(); e.hasMoreElements();
        )
         {
         PrimitiveHead he = (PrimitiveHead)(e.nextElement());
         he.text.plan(xNode, yy);
         yy += he.text.height + vd;
         }
       }
       }
     x = x0;
     y = y0;
       {
       if(
       sk instanceof Sketch
       ){
       height = hh + hhe + vstep;
       Branch bb = ((Sketch)sk).branch(0);
       Rectangle re = getNodeArea(sk);
       bb.comment.x = (re.x + re.x + re.width)/2 - hd;
       bb.comment.y = re.y + re.height + vd;
       }
       }
       {
       if(
       sk instanceof Branch
       ){
       height = hh + hhe;
       }
       }
     }
    public void  draw(Graphics g)
     {
     Scheme s = super.sk;
     Scheme parent = s.parent;
       {
       if(
       s.icon
       ){
        L3:
         {
           {
           if(
           s instanceof Sketch
           ){
           g.setColor(color);
           break L3;
           }
           }
         g.setColor(colorBr);
         }
       int luX = x + 6;
       int luY = y + 2;
       g.drawRect(luX, luY, iconw, iconh);
       g.drawLine(luX, luY, luX + iconw - 1, luY + iconh - 1);
         {
         if(
         s instanceof Sketch
         ){
         if(
         parent != null
         ){
         parent = parent.parent;
         if(
         parent.view.type == View.STREE
         ){
         Rectangle r = getNodeArea(parent);
         int xParent = r.x + r.width/2;
         int yParent = r.y + r.height;
         g.drawLine(luX + iconw/2, luY, xParent, yParent);
         }
         }
         }
         }
       return;
       }
       }
       {
       if(
       s instanceof Sketch
       ){
         {
         //?((Sketch)s).containsSubsketch()
         drawSkLine(g,s);
         }
       s.comment.draw(g);
       }
       }
     int yy = s.comment.height + vd;
     int x1 = x + hd/2;
     Rectangle rk = getNodeArea(sk);
       {
       if(
       s instanceof Sketch
       ){
       g.drawOval(rk.x, rk.y, rk.width, rk.height);
        L4:
         {
           {
           if(
           s.type == Scheme.MODULE
           ){
           g.drawOval(rk.x-1, rk.y-1, rk.width+2, rk.height+2);
           break L4;
           }
           }
         if(
         s.type == Scheme.LOOP
         ){
         g.drawOval(rk.x-2, rk.y-2, rk.width+4, rk.height+4);
         }
         }
       }
       }
       {
       if(
       s instanceof Sketch
       ){
       if(
       parent != null
       ){
       parent = parent.parent;
       if(
       parent.view.type == View.STREE
       ){
       Rectangle r = getNodeArea(parent);
       int xParent = r.x + r.width/2;
       int yParent = r.y + r.height;
       g.drawLine(rk.x +rk.width/2, rk.y, xParent, yParent);
       }
       }
       }
       }
      for(
      Enumeration e = s.head.elements(); e.hasMoreElements();
      )
       {
       PrimitiveHead he = (PrimitiveHead)(e.nextElement());
       he.text.draw(g);
       g.setColor(color);
        switch(
        he.type
        )
        {
         case
         PrimitiveHead.LOOP:
         g.setFont(Default.font);
         g.drawString("*", x1, y+yy + he.text.height*3/4);
         break;
         case
         PrimitiveHead.SWITCH:
         g.setFont(Default.font);
         g.drawString("??", x1, y+yy + he.text.height*3/4);
         break;
         case
         PrimitiveHead.CASE:
         case
         PrimitiveHead.DEFAULT:
         g.setFont(Default.font);
         g.drawString("?", x1, y+yy + he.text.height*3/4);
         break;
         case
         PrimitiveHead.TRY:
         g.setFont(Default.font);
         g.drawString("!!", x1, y+yy + he.text.height*3/4);
         break;
         case
         PrimitiveHead.CATCH:
         case
         PrimitiveHead.FINALLY:
         g.setFont(Default.font);
         g.drawString("!", x1, y+yy + he.text.height*3/4);
         break;
        }
       yy += he.text.height;
       }
      for(
      Enumeration e = s.body.elements(); e.hasMoreElements();
      )
       {
       Object o = e.nextElement();
       if(
       o instanceof Scheme
       ){
       Scheme sss = (Scheme)o;
       sss.view.draw(g);
       if(
       (sss instanceof Sketch) && (sss.view.type != View.STREE)
       ){
        Rectangle r = getNodeArea(s.parent);
       int xParent = r.x + r.width/2;
       int yParent = r.y + r.height;
       g.drawLine(sss.view.x +sss.view.width/2, sss.view.y, xParent, yParent);
       }
       }
       }
     }
    public void pointLocation(Point p, Scheme s)
     {
       {
       if(
       (result != null)
       ){
       return;
       }
       }
       {
       if(
       (!s.view.contains(p))
       ){
       return;
       }
       }
       {
       if(
       (s.icon)
       ){
       result = new Cursor(s);
       return;
       }
       }
      L5:
      for(
      int i = 0; i < s.body.size(); i++
      )
       {
       Object o = s.member(i);
         {
         if(
          (o instanceof Scheme)
         ){
         Scheme sk = (Scheme)o;
         pointLocation(p, sk);
           {
           if(
           (result != null)
           ){
           return;
           }
           }
         continue L5;
         }
         }
       }
     result = new Cursor(s);
       {
       if(
       (pointLocation(p, s.comment))
       ){
       result.primitive = null;
         {
         result.noInRow = 1;
         if(
         s instanceof Sketch
         ){
         Row r = result.row;
         int shift = (((Symbol)r.elements.elementAt(0))).width();
          L7:
          for(
          int i = 1; i < r.elements.size(); i++
          )
           {
             {
             if(
             ((r.x + shift) > p.x)
             ){
             break L7;
             }
             }
           result.noInRow++;
           r.getElement(i);
             {
             if(
             (r.sy != null)
             ){
             shift += r.sy.width();
             continue L7;
             }
             }
           ;
           }
         }
         }
       return;
       }
       }
       {
       if(
       s instanceof Sketch
       ){
       result = null;
       result = new Cursor(s);
        for(
        Enumeration e = s.head.elements(); e.hasMoreElements();
        )
         {
         PrimitiveHead h = (PrimitiveHead)(e.nextElement());
         if(
         (pointLocation(p, h.text))
         ){
         result.primitive = h;
         result.noInRow = 1;
         Row r = result.row;
         int shift = (((Symbol)r.elements.elementAt(0))).width();
          L8:
          for(
          int i = 1; i < r.elements.size(); i++
          )
           {
             {
             if(
             ((r.x + shift) > p.x)
             ){
             break L8;
             }
             }
           result.noInRow++;
           r.getElement(i);
             {
             if(
             (r.sy != null)
             ){
             shift += r.sy.width();
             continue L8;
             }
             }
           ;
           }
         return;
         }
         }
       }
       }
     Rectangle rec = getLineArea(s);
     rec.width -= hd/2;
       {
       if(
       (s instanceof Sketch) && (rec.contains(p))
       ){
       result = new Cursor(s);
       return;
       }
       }
     result = null;
     }
   }
